/* Downloader.c generated by valac 0.16.0, the Vala compiler
 * generated from Downloader.vala, do not modify */

/* Part of MuttonChop
 * copyright 2012 Jezra Lickter
 * Licensed GPLv3
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <gio/gio.h>
#include <glib/gstdio.h>
#include <gobject/gvaluecollector.h>


#define TYPE_DOWNLOADER_INFO (downloader_info_get_type ())
typedef struct _DownloaderInfo DownloaderInfo;
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_PARSED_URL (parsed_url_get_type ())
#define PARSED_URL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PARSED_URL, ParsedURL))
#define PARSED_URL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PARSED_URL, ParsedURLClass))
#define IS_PARSED_URL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PARSED_URL))
#define IS_PARSED_URL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PARSED_URL))
#define PARSED_URL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PARSED_URL, ParsedURLClass))

typedef struct _ParsedURL ParsedURL;
typedef struct _ParsedURLClass ParsedURLClass;
typedef struct _ParsedURLPrivate ParsedURLPrivate;
typedef struct _ParamSpecParsedURL ParamSpecParsedURL;

#define TYPE_HEADER (header_get_type ())
#define HEADER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_HEADER, Header))
#define HEADER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_HEADER, HeaderClass))
#define IS_HEADER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_HEADER))
#define IS_HEADER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_HEADER))
#define HEADER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_HEADER, HeaderClass))

typedef struct _Header Header;
typedef struct _HeaderClass HeaderClass;
typedef struct _HeaderPrivate HeaderPrivate;
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_match_info_free0(var) ((var == NULL) ? NULL : (var = (g_match_info_free (var), NULL)))
typedef struct _ParamSpecHeader ParamSpecHeader;

#define TYPE_DOWNLOADER (downloader_get_type ())
#define DOWNLOADER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DOWNLOADER, Downloader))
#define DOWNLOADER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DOWNLOADER, DownloaderClass))
#define IS_DOWNLOADER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DOWNLOADER))
#define IS_DOWNLOADER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DOWNLOADER))
#define DOWNLOADER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DOWNLOADER, DownloaderClass))

typedef struct _Downloader Downloader;
typedef struct _DownloaderClass DownloaderClass;
typedef struct _DownloaderPrivate DownloaderPrivate;
#define _parsed_url_unref0(var) ((var == NULL) ? NULL : (var = (parsed_url_unref (var), NULL)))
#define _header_unref0(var) ((var == NULL) ? NULL : (var = (header_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define __g_list_free__g_object_unref0_0(var) ((var == NULL) ? NULL : (var = (_g_list_free__g_object_unref0_ (var), NULL)))

typedef enum  {
	URL_ERROR_INVALID
} URLError;
#define URL_ERROR url_error_quark ()
struct _DownloaderInfo {
	gchar* id;
	gchar* feed_title;
	gchar* title;
	guint64 length;
	guint64 bytes_downloaded;
};

struct _ParsedURL {
	GTypeInstance parent_instance;
	volatile int ref_count;
	ParsedURLPrivate * priv;
	gchar* scheme;
	gchar* host;
	gint port;
	gchar* request;
	gchar* query;
};

struct _ParsedURLClass {
	GTypeClass parent_class;
	void (*finalize) (ParsedURL *self);
};

struct _ParamSpecParsedURL {
	GParamSpec parent_instance;
};

struct _Header {
	GTypeInstance parent_instance;
	volatile int ref_count;
	HeaderPrivate * priv;
	gchar* status;
	gchar* Date;
	gchar* Server;
	gchar* Location;
	guint64 Content_Length;
	gchar* Content_Type;
	gchar* Transfer_Encoding;
	gchar* code;
	gchar* version;
};

struct _HeaderClass {
	GTypeClass parent_class;
	void (*finalize) (Header *self);
};

struct _HeaderPrivate {
	GRegex* key_value_regex;
};

struct _ParamSpecHeader {
	GParamSpec parent_instance;
};

struct _Downloader {
	GObject parent_instance;
	DownloaderPrivate * priv;
	guint64 length;
	guint64 bytes_read;
	gchar* title;
	gchar* local_file_path;
};

struct _DownloaderClass {
	GObjectClass parent_class;
};

struct _DownloaderPrivate {
	DownloaderInfo dli;
	gint dl_length;
	gint throttler;
	gboolean download_complete;
	gboolean downloader_finished;
	gchar* url;
	gboolean kill_download;
	gboolean borked;
	gboolean debug;
};


static gpointer parsed_url_parent_class = NULL;
static gpointer header_parent_class = NULL;
static gpointer downloader_parent_class = NULL;

GQuark url_error_quark (void);
GType downloader_info_get_type (void) G_GNUC_CONST;
DownloaderInfo* downloader_info_dup (const DownloaderInfo* self);
void downloader_info_free (DownloaderInfo* self);
void downloader_info_copy (const DownloaderInfo* self, DownloaderInfo* dest);
void downloader_info_destroy (DownloaderInfo* self);
gpointer parsed_url_ref (gpointer instance);
void parsed_url_unref (gpointer instance);
GParamSpec* param_spec_parsed_url (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_parsed_url (GValue* value, gpointer v_object);
void value_take_parsed_url (GValue* value, gpointer v_object);
gpointer value_get_parsed_url (const GValue* value);
GType parsed_url_get_type (void) G_GNUC_CONST;
enum  {
	PARSED_URL_DUMMY_PROPERTY
};
ParsedURL* parsed_url_new (void);
ParsedURL* parsed_url_construct (GType object_type);
void parsed_url_parse (ParsedURL* self, const gchar* url, GError** error);
static void parsed_url_finalize (ParsedURL* obj);
gpointer header_ref (gpointer instance);
void header_unref (gpointer instance);
GParamSpec* param_spec_header (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_header (GValue* value, gpointer v_object);
void value_take_header (GValue* value, gpointer v_object);
gpointer value_get_header (const GValue* value);
GType header_get_type (void) G_GNUC_CONST;
#define HEADER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_HEADER, HeaderPrivate))
enum  {
	HEADER_DUMMY_PROPERTY
};
Header* header_new (void);
Header* header_construct (GType object_type);
void header_add_value (Header* self, const gchar* line);
static void header_finalize (Header* obj);
GType downloader_get_type (void) G_GNUC_CONST;
#define DOWNLOADER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_DOWNLOADER, DownloaderPrivate))
enum  {
	DOWNLOADER_DUMMY_PROPERTY
};
Downloader* downloader_new (const gchar* url, const gchar* local_file, gint* throttler);
Downloader* downloader_construct (GType object_type, const gchar* url, const gchar* local_file, gint* throttler);
void downloader_set_debug (Downloader* self, gboolean val);
gboolean downloader_is_borked (Downloader* self);
void downloader_kill (Downloader* self);
void downloader_get_info (Downloader* self, DownloaderInfo* result);
void downloader_set_feed_title (Downloader* self, const gchar* feed_title);
void downloader_set_title (Downloader* self, const gchar* title);
void downloader_set_id (Downloader* self, const gchar* id);
void downloader_run (Downloader* self);
static void downloader_download (Downloader* self, const gchar* remote, gint redirects);
void downloader_run_async (Downloader* self);
static void* downloader_thread_download (Downloader* self);
static gpointer _downloader_thread_download_gthread_func (gpointer self);
static void _g_object_unref0_ (gpointer var);
static void _g_list_free__g_object_unref0_ (GList* self);
gint downloader_hextoint (Downloader* self, const gchar* hex);
static void _vala_array_add12 (guint8** array, int* length, int* size, guint8 value);
static void downloader_move_partial (Downloader* self, const gchar* old_file, const gchar* new_file);
gint downloader_hexval (Downloader* self, const gchar* c);
static void downloader_finalize (GObject* obj);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


GQuark url_error_quark (void) {
	return g_quark_from_static_string ("url_error-quark");
}


void downloader_info_copy (const DownloaderInfo* self, DownloaderInfo* dest) {
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	guint64 _tmp6_;
	guint64 _tmp7_;
	_tmp0_ = (*self).id;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 ((*dest).id);
	(*dest).id = _tmp1_;
	_tmp2_ = (*self).feed_title;
	_tmp3_ = g_strdup (_tmp2_);
	_g_free0 ((*dest).feed_title);
	(*dest).feed_title = _tmp3_;
	_tmp4_ = (*self).title;
	_tmp5_ = g_strdup (_tmp4_);
	_g_free0 ((*dest).title);
	(*dest).title = _tmp5_;
	_tmp6_ = (*self).length;
	(*dest).length = _tmp6_;
	_tmp7_ = (*self).bytes_downloaded;
	(*dest).bytes_downloaded = _tmp7_;
}


void downloader_info_destroy (DownloaderInfo* self) {
	_g_free0 ((*self).id);
	_g_free0 ((*self).feed_title);
	_g_free0 ((*self).title);
}


DownloaderInfo* downloader_info_dup (const DownloaderInfo* self) {
	DownloaderInfo* dup;
	dup = g_new0 (DownloaderInfo, 1);
	downloader_info_copy (self, dup);
	return dup;
}


void downloader_info_free (DownloaderInfo* self) {
	downloader_info_destroy (self);
	g_free (self);
}


GType downloader_info_get_type (void) {
	static volatile gsize downloader_info_type_id__volatile = 0;
	if (g_once_init_enter (&downloader_info_type_id__volatile)) {
		GType downloader_info_type_id;
		downloader_info_type_id = g_boxed_type_register_static ("DownloaderInfo", (GBoxedCopyFunc) downloader_info_dup, (GBoxedFreeFunc) downloader_info_free);
		g_once_init_leave (&downloader_info_type_id__volatile, downloader_info_type_id);
	}
	return downloader_info_type_id__volatile;
}


ParsedURL* parsed_url_construct (GType object_type) {
	ParsedURL* self = NULL;
	self = (ParsedURL*) g_type_create_instance (object_type);
	return self;
}


ParsedURL* parsed_url_new (void) {
	return parsed_url_construct (TYPE_PARSED_URL);
}


static const gchar* string_to_string (const gchar* self) {
	const gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	result = self;
	return result;
}


void parsed_url_parse (ParsedURL* self, const gchar* url, GError** error) {
	gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar** _tmp2_;
	gchar** _tmp3_ = NULL;
	gchar** bits;
	gint bits_length1;
	gint _bits_size_;
	gchar** _tmp4_;
	gint _tmp4__length1;
	gchar** _tmp11_;
	gint _tmp11__length1;
	const gchar* _tmp12_;
	gchar* _tmp13_;
	const gchar* _tmp14_;
	gchar* _tmp15_ = NULL;
	gchar* _tmp16_;
	gboolean _tmp17_;
	const gchar* _tmp18_;
	gchar* _tmp19_ = NULL;
	gchar* _tmp20_;
	gboolean _tmp21_;
	gchar** _tmp22_;
	gint _tmp22__length1;
	const gchar* _tmp23_;
	gchar** _tmp24_;
	gchar** _tmp25_ = NULL;
	gchar** _tmp26_;
	gint _tmp26__length1;
	const gchar* _tmp27_;
	gchar* _tmp28_;
	gchar* hp;
	const gchar* _tmp29_;
	gchar** _tmp30_;
	gchar** _tmp31_ = NULL;
	gchar** hpbits;
	gint hpbits_length1;
	gint _hpbits_size_;
	gchar** _tmp32_;
	gint _tmp32__length1;
	const gchar* _tmp33_;
	gchar* _tmp34_;
	gchar** _tmp35_;
	gint _tmp35__length1;
	gchar** _tmp39_;
	gint _tmp39__length1;
	const gchar* _tmp53_;
	gchar** _tmp54_;
	gchar** _tmp55_ = NULL;
	gchar** _tmp56_;
	gint _tmp56__length1;
	const gchar* _tmp57_;
	gchar* _tmp58_;
	gchar** _tmp59_;
	gint _tmp59__length1;
	const gchar* _tmp60_;
	gchar* _tmp61_;
	gchar* _tmp62_;
	const gchar* _tmp63_;
	const gchar* _tmp65_;
	gchar* _tmp66_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (url != NULL);
	_tmp0_ = g_strdup ("");
	_g_free0 (self->request);
	self->request = _tmp0_;
	_tmp1_ = url;
	_tmp3_ = _tmp2_ = g_strsplit (_tmp1_, "://", 2);
	bits = _tmp3_;
	bits_length1 = _vala_array_length (_tmp2_);
	_bits_size_ = bits_length1;
	_tmp4_ = bits;
	_tmp4__length1 = bits_length1;
	if (_tmp4__length1 != 2) {
		const gchar* _tmp5_;
		const gchar* _tmp6_ = NULL;
		gchar* _tmp7_ = NULL;
		gchar* _tmp8_;
		GError* _tmp9_;
		GError* _tmp10_;
		_tmp5_ = url;
		_tmp6_ = string_to_string (_tmp5_);
		_tmp7_ = g_strconcat (_tmp6_, " is not a valid URL", NULL);
		_tmp8_ = _tmp7_;
		_tmp9_ = g_error_new_literal (URL_ERROR, URL_ERROR_INVALID, _tmp8_);
		_tmp10_ = _tmp9_;
		_g_free0 (_tmp8_);
		_inner_error_ = _tmp10_;
		if (_inner_error_->domain == URL_ERROR) {
			g_propagate_error (error, _inner_error_);
			bits = (_vala_array_free (bits, bits_length1, (GDestroyNotify) g_free), NULL);
			return;
		} else {
			bits = (_vala_array_free (bits, bits_length1, (GDestroyNotify) g_free), NULL);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	_tmp11_ = bits;
	_tmp11__length1 = bits_length1;
	_tmp12_ = _tmp11_[0];
	_tmp13_ = g_strdup (_tmp12_);
	_g_free0 (self->scheme);
	self->scheme = _tmp13_;
	_tmp14_ = self->scheme;
	_tmp15_ = g_utf8_strdown (_tmp14_, (gssize) (-1));
	_tmp16_ = _tmp15_;
	_tmp17_ = g_strcmp0 (_tmp16_, "http") == 0;
	_g_free0 (_tmp16_);
	if (_tmp17_) {
		self->port = 80;
	}
	_tmp18_ = self->scheme;
	_tmp19_ = g_utf8_strdown (_tmp18_, (gssize) (-1));
	_tmp20_ = _tmp19_;
	_tmp21_ = g_strcmp0 (_tmp20_, "ftp") == 0;
	_g_free0 (_tmp20_);
	if (_tmp21_) {
		self->port = 21;
	}
	_tmp22_ = bits;
	_tmp22__length1 = bits_length1;
	_tmp23_ = _tmp22_[1];
	_tmp25_ = _tmp24_ = g_strsplit (_tmp23_, "/", 0);
	bits = (_vala_array_free (bits, bits_length1, (GDestroyNotify) g_free), NULL);
	bits = _tmp25_;
	bits_length1 = _vala_array_length (_tmp24_);
	_bits_size_ = bits_length1;
	_tmp26_ = bits;
	_tmp26__length1 = bits_length1;
	_tmp27_ = _tmp26_[0];
	_tmp28_ = g_strdup (_tmp27_);
	hp = _tmp28_;
	_tmp29_ = hp;
	_tmp31_ = _tmp30_ = g_strsplit (_tmp29_, ":", 0);
	hpbits = _tmp31_;
	hpbits_length1 = _vala_array_length (_tmp30_);
	_hpbits_size_ = hpbits_length1;
	_tmp32_ = hpbits;
	_tmp32__length1 = hpbits_length1;
	_tmp33_ = _tmp32_[0];
	_tmp34_ = g_strdup (_tmp33_);
	_g_free0 (self->host);
	self->host = _tmp34_;
	_tmp35_ = hpbits;
	_tmp35__length1 = hpbits_length1;
	if (_tmp35__length1 > 1) {
		gchar** _tmp36_;
		gint _tmp36__length1;
		const gchar* _tmp37_;
		gint _tmp38_ = 0;
		_tmp36_ = hpbits;
		_tmp36__length1 = hpbits_length1;
		_tmp37_ = _tmp36_[1];
		_tmp38_ = atoi (_tmp37_);
		self->port = _tmp38_;
	}
	_tmp39_ = bits;
	_tmp39__length1 = bits_length1;
	if (_tmp39__length1 > 1) {
		{
			gint i;
			i = 1;
			{
				gboolean _tmp40_;
				_tmp40_ = TRUE;
				while (TRUE) {
					gboolean _tmp41_;
					gint _tmp43_;
					gchar** _tmp44_;
					gint _tmp44__length1;
					const gchar* _tmp45_;
					gchar** _tmp46_;
					gint _tmp46__length1;
					gint _tmp47_;
					const gchar* _tmp48_;
					gchar* _tmp49_;
					gchar* _tmp50_;
					gchar* _tmp51_;
					_tmp41_ = _tmp40_;
					if (!_tmp41_) {
						gint _tmp42_;
						_tmp42_ = i;
						i = _tmp42_ + 1;
					}
					_tmp40_ = FALSE;
					_tmp43_ = i;
					_tmp44_ = bits;
					_tmp44__length1 = bits_length1;
					if (!(_tmp43_ < _tmp44__length1)) {
						break;
					}
					_tmp45_ = self->request;
					_tmp46_ = bits;
					_tmp46__length1 = bits_length1;
					_tmp47_ = i;
					_tmp48_ = _tmp46_[_tmp47_];
					_tmp49_ = g_strconcat ("/", _tmp48_, NULL);
					_tmp50_ = _tmp49_;
					_tmp51_ = g_strconcat (_tmp45_, _tmp50_, NULL);
					_g_free0 (self->request);
					self->request = _tmp51_;
					_g_free0 (_tmp50_);
				}
			}
		}
	} else {
		gchar* _tmp52_;
		_tmp52_ = g_strdup ("/");
		_g_free0 (self->request);
		self->request = _tmp52_;
	}
	_tmp53_ = self->request;
	_tmp55_ = _tmp54_ = g_strsplit (_tmp53_, "?", 0);
	bits = (_vala_array_free (bits, bits_length1, (GDestroyNotify) g_free), NULL);
	bits = _tmp55_;
	bits_length1 = _vala_array_length (_tmp54_);
	_bits_size_ = bits_length1;
	_tmp56_ = bits;
	_tmp56__length1 = bits_length1;
	_tmp57_ = _tmp56_[0];
	_tmp58_ = g_strdup (_tmp57_);
	_g_free0 (self->request);
	self->request = _tmp58_;
	_tmp59_ = bits;
	_tmp59__length1 = bits_length1;
	_tmp60_ = _tmp59_[1];
	_tmp61_ = g_strdup (_tmp60_);
	_tmp62_ = _tmp61_;
	_tmp63_ = _tmp62_;
	if (_tmp63_ == NULL) {
		gchar* _tmp64_;
		_tmp64_ = g_strdup ("");
		_g_free0 (_tmp62_);
		_tmp62_ = _tmp64_;
	}
	_tmp65_ = _tmp62_;
	_tmp66_ = g_strdup (_tmp65_);
	_g_free0 (self->query);
	self->query = _tmp66_;
	_g_free0 (_tmp62_);
	hpbits = (_vala_array_free (hpbits, hpbits_length1, (GDestroyNotify) g_free), NULL);
	_g_free0 (hp);
	bits = (_vala_array_free (bits, bits_length1, (GDestroyNotify) g_free), NULL);
}


static void value_parsed_url_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void value_parsed_url_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		parsed_url_unref (value->data[0].v_pointer);
	}
}


static void value_parsed_url_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = parsed_url_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer value_parsed_url_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* value_parsed_url_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		ParsedURL* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = parsed_url_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* value_parsed_url_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	ParsedURL** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = parsed_url_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* param_spec_parsed_url (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecParsedURL* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_PARSED_URL), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer value_get_parsed_url (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PARSED_URL), NULL);
	return value->data[0].v_pointer;
}


void value_set_parsed_url (GValue* value, gpointer v_object) {
	ParsedURL* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PARSED_URL));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PARSED_URL));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		parsed_url_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		parsed_url_unref (old);
	}
}


void value_take_parsed_url (GValue* value, gpointer v_object) {
	ParsedURL* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PARSED_URL));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PARSED_URL));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		parsed_url_unref (old);
	}
}


static void parsed_url_class_init (ParsedURLClass * klass) {
	parsed_url_parent_class = g_type_class_peek_parent (klass);
	PARSED_URL_CLASS (klass)->finalize = parsed_url_finalize;
}


static void parsed_url_instance_init (ParsedURL * self) {
	self->ref_count = 1;
}


static void parsed_url_finalize (ParsedURL* obj) {
	ParsedURL * self;
	self = PARSED_URL (obj);
	_g_free0 (self->scheme);
	_g_free0 (self->host);
	_g_free0 (self->request);
	_g_free0 (self->query);
}


GType parsed_url_get_type (void) {
	static volatile gsize parsed_url_type_id__volatile = 0;
	if (g_once_init_enter (&parsed_url_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_parsed_url_init, value_parsed_url_free_value, value_parsed_url_copy_value, value_parsed_url_peek_pointer, "p", value_parsed_url_collect_value, "p", value_parsed_url_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (ParsedURLClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) parsed_url_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ParsedURL), 0, (GInstanceInitFunc) parsed_url_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType parsed_url_type_id;
		parsed_url_type_id = g_type_register_fundamental (g_type_fundamental_next (), "ParsedURL", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&parsed_url_type_id__volatile, parsed_url_type_id);
	}
	return parsed_url_type_id__volatile;
}


gpointer parsed_url_ref (gpointer instance) {
	ParsedURL* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void parsed_url_unref (gpointer instance) {
	ParsedURL* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		PARSED_URL_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


Header* header_construct (GType object_type) {
	Header* self = NULL;
	GError * _inner_error_ = NULL;
	self = (Header*) g_type_create_instance (object_type);
	{
		GRegex* _tmp0_;
		GRegex* _tmp1_;
		_tmp0_ = g_regex_new ("(?P<key>.*):\\s+(?P<value>.*)", 0, 0, &_inner_error_);
		_tmp1_ = _tmp0_;
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch11_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_g_regex_unref0 (self->priv->key_value_regex);
		self->priv->key_value_regex = _tmp1_;
	}
	goto __finally11;
	__catch11_g_regex_error:
	{
		GError* err = NULL;
		FILE* _tmp2_;
		GError* _tmp3_;
		const gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		err = _inner_error_;
		_inner_error_ = NULL;
		_tmp2_ = stderr;
		_tmp3_ = err;
		_tmp4_ = _tmp3_->message;
		_tmp5_ = g_strconcat (_tmp4_, "\n", NULL);
		_tmp6_ = _tmp5_;
		fprintf (_tmp2_, "%s", _tmp6_);
		_g_free0 (_tmp6_);
		_g_error_free0 (err);
	}
	__finally11:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	return self;
}


Header* header_new (void) {
	return header_construct (TYPE_HEADER);
}


static gchar* string_slice (const gchar* self, glong start, glong end) {
	gchar* result = NULL;
	gint _tmp0_;
	gint _tmp1_;
	glong string_length;
	glong _tmp2_;
	glong _tmp5_;
	gboolean _tmp8_ = FALSE;
	glong _tmp9_;
	gboolean _tmp12_;
	gboolean _tmp13_ = FALSE;
	glong _tmp14_;
	gboolean _tmp17_;
	glong _tmp18_;
	glong _tmp19_;
	glong _tmp20_;
	glong _tmp21_;
	glong _tmp22_;
	gchar* _tmp23_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = strlen (self);
	_tmp1_ = _tmp0_;
	string_length = (glong) _tmp1_;
	_tmp2_ = start;
	if (_tmp2_ < ((glong) 0)) {
		glong _tmp3_;
		glong _tmp4_;
		_tmp3_ = string_length;
		_tmp4_ = start;
		start = _tmp3_ + _tmp4_;
	}
	_tmp5_ = end;
	if (_tmp5_ < ((glong) 0)) {
		glong _tmp6_;
		glong _tmp7_;
		_tmp6_ = string_length;
		_tmp7_ = end;
		end = _tmp6_ + _tmp7_;
	}
	_tmp9_ = start;
	if (_tmp9_ >= ((glong) 0)) {
		glong _tmp10_;
		glong _tmp11_;
		_tmp10_ = start;
		_tmp11_ = string_length;
		_tmp8_ = _tmp10_ <= _tmp11_;
	} else {
		_tmp8_ = FALSE;
	}
	_tmp12_ = _tmp8_;
	g_return_val_if_fail (_tmp12_, NULL);
	_tmp14_ = end;
	if (_tmp14_ >= ((glong) 0)) {
		glong _tmp15_;
		glong _tmp16_;
		_tmp15_ = end;
		_tmp16_ = string_length;
		_tmp13_ = _tmp15_ <= _tmp16_;
	} else {
		_tmp13_ = FALSE;
	}
	_tmp17_ = _tmp13_;
	g_return_val_if_fail (_tmp17_, NULL);
	_tmp18_ = start;
	_tmp19_ = end;
	g_return_val_if_fail (_tmp18_ <= _tmp19_, NULL);
	_tmp20_ = start;
	_tmp21_ = end;
	_tmp22_ = start;
	_tmp23_ = g_strndup (((gchar*) self) + _tmp20_, (gsize) (_tmp21_ - _tmp22_));
	result = _tmp23_;
	return result;
}


static guint64 uint64_parse (const gchar* str) {
	guint64 result = 0ULL;
	const gchar* _tmp0_;
	guint64 _tmp1_ = 0ULL;
	g_return_val_if_fail (str != NULL, 0ULL);
	_tmp0_ = str;
	_tmp1_ = g_ascii_strtoull (_tmp0_, NULL, (guint) 0);
	result = _tmp1_;
	return result;
}


void header_add_value (Header* self, const gchar* line) {
	const gchar* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (line != NULL);
	_tmp0_ = self->status;
	if (_tmp0_ == NULL) {
		const gchar* _tmp1_;
		gchar* _tmp2_;
		const gchar* _tmp3_;
		gchar** _tmp4_;
		gchar** _tmp5_ = NULL;
		gchar** line_bits;
		gint line_bits_length1;
		gint _line_bits_size_;
		gchar** _tmp6_;
		gint _tmp6__length1;
		const gchar* _tmp7_;
		gchar* _tmp8_;
		gchar** _tmp9_;
		gint _tmp9__length1;
		const gchar* _tmp10_;
		gchar** _tmp11_;
		gint _tmp11__length1;
		const gchar* _tmp12_;
		gint _tmp13_;
		gint _tmp14_;
		gchar* _tmp15_ = NULL;
		_tmp1_ = line;
		_tmp2_ = g_strdup (_tmp1_);
		_g_free0 (self->status);
		self->status = _tmp2_;
		_tmp3_ = self->status;
		_tmp5_ = _tmp4_ = g_strsplit (_tmp3_, " ", 0);
		line_bits = _tmp5_;
		line_bits_length1 = _vala_array_length (_tmp4_);
		_line_bits_size_ = line_bits_length1;
		_tmp6_ = line_bits;
		_tmp6__length1 = line_bits_length1;
		_tmp7_ = _tmp6_[1];
		_tmp8_ = g_strdup (_tmp7_);
		_g_free0 (self->code);
		self->code = _tmp8_;
		_tmp9_ = line_bits;
		_tmp9__length1 = line_bits_length1;
		_tmp10_ = _tmp9_[0];
		_tmp11_ = line_bits;
		_tmp11__length1 = line_bits_length1;
		_tmp12_ = _tmp11_[0];
		_tmp13_ = strlen (_tmp12_);
		_tmp14_ = _tmp13_;
		_tmp15_ = string_slice (_tmp10_, (glong) (-3), (glong) _tmp14_);
		_g_free0 (self->version);
		self->version = _tmp15_;
		line_bits = (_vala_array_free (line_bits, line_bits_length1, (GDestroyNotify) g_free), NULL);
	} else {
		GMatchInfo* match_info = NULL;
		gchar* key = NULL;
		gchar* val = NULL;
		GRegex* _tmp16_;
		const gchar* _tmp17_;
		GMatchInfo* _tmp18_ = NULL;
		gboolean _tmp19_ = FALSE;
		_tmp16_ = self->priv->key_value_regex;
		_tmp17_ = line;
		_tmp19_ = g_regex_match (_tmp16_, _tmp17_, G_REGEX_MATCH_ANCHORED, &_tmp18_);
		_g_match_info_free0 (match_info);
		match_info = _tmp18_;
		if (_tmp19_) {
			GMatchInfo* _tmp20_;
			gchar* _tmp21_ = NULL;
			GMatchInfo* _tmp22_;
			gchar* _tmp23_ = NULL;
			const gchar* _tmp24_;
			const gchar* _tmp25_;
			GQuark _tmp27_ = 0U;
			static GQuark _tmp26_label0 = 0;
			static GQuark _tmp26_label1 = 0;
			static GQuark _tmp26_label2 = 0;
			static GQuark _tmp26_label3 = 0;
			static GQuark _tmp26_label4 = 0;
			static GQuark _tmp26_label5 = 0;
			_tmp20_ = match_info;
			_tmp21_ = g_match_info_fetch_named (_tmp20_, "key");
			_g_free0 (key);
			key = _tmp21_;
			_tmp22_ = match_info;
			_tmp23_ = g_match_info_fetch_named (_tmp22_, "value");
			_g_free0 (val);
			val = _tmp23_;
			_tmp24_ = key;
			_tmp25_ = _tmp24_;
			_tmp27_ = (NULL == _tmp25_) ? 0 : g_quark_from_string (_tmp25_);
			if (_tmp27_ == ((0 != _tmp26_label0) ? _tmp26_label0 : (_tmp26_label0 = g_quark_from_static_string ("Date")))) {
				switch (0) {
					default:
					{
						const gchar* _tmp28_;
						gchar* _tmp29_;
						_tmp28_ = val;
						_tmp29_ = g_strdup (_tmp28_);
						_g_free0 (self->Date);
						self->Date = _tmp29_;
						break;
					}
				}
			} else if (_tmp27_ == ((0 != _tmp26_label1) ? _tmp26_label1 : (_tmp26_label1 = g_quark_from_static_string ("Server")))) {
				switch (0) {
					default:
					{
						const gchar* _tmp30_;
						gchar* _tmp31_;
						_tmp30_ = val;
						_tmp31_ = g_strdup (_tmp30_);
						_g_free0 (self->Server);
						self->Server = _tmp31_;
						break;
					}
				}
			} else if (_tmp27_ == ((0 != _tmp26_label2) ? _tmp26_label2 : (_tmp26_label2 = g_quark_from_static_string ("Location")))) {
				switch (0) {
					default:
					{
						const gchar* _tmp32_;
						gchar* _tmp33_;
						_tmp32_ = val;
						_tmp33_ = g_strdup (_tmp32_);
						_g_free0 (self->Location);
						self->Location = _tmp33_;
						break;
					}
				}
			} else if (_tmp27_ == ((0 != _tmp26_label3) ? _tmp26_label3 : (_tmp26_label3 = g_quark_from_static_string ("Content-Length")))) {
				switch (0) {
					default:
					{
						const gchar* _tmp34_;
						guint64 _tmp35_ = 0ULL;
						_tmp34_ = val;
						_tmp35_ = uint64_parse (_tmp34_);
						self->Content_Length = _tmp35_;
						break;
					}
				}
			} else if (_tmp27_ == ((0 != _tmp26_label4) ? _tmp26_label4 : (_tmp26_label4 = g_quark_from_static_string ("Content-Type")))) {
				switch (0) {
					default:
					{
						const gchar* _tmp36_;
						gchar* _tmp37_;
						_tmp36_ = val;
						_tmp37_ = g_strdup (_tmp36_);
						_g_free0 (self->Content_Type);
						self->Content_Type = _tmp37_;
						break;
					}
				}
			} else if (_tmp27_ == ((0 != _tmp26_label5) ? _tmp26_label5 : (_tmp26_label5 = g_quark_from_static_string ("Transfer-Encoding")))) {
				switch (0) {
					default:
					{
						const gchar* _tmp38_;
						gchar* _tmp39_;
						_tmp38_ = val;
						_tmp39_ = g_strdup (_tmp38_);
						_g_free0 (self->Transfer_Encoding);
						self->Transfer_Encoding = _tmp39_;
						break;
					}
				}
			} else {
				switch (0) {
					default:
					{
						break;
					}
				}
			}
		}
		_g_free0 (val);
		_g_free0 (key);
		_g_match_info_free0 (match_info);
	}
}


static void value_header_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void value_header_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		header_unref (value->data[0].v_pointer);
	}
}


static void value_header_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = header_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer value_header_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* value_header_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		Header* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = header_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* value_header_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	Header** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = header_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* param_spec_header (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecHeader* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_HEADER), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer value_get_header (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_HEADER), NULL);
	return value->data[0].v_pointer;
}


void value_set_header (GValue* value, gpointer v_object) {
	Header* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_HEADER));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_HEADER));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		header_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		header_unref (old);
	}
}


void value_take_header (GValue* value, gpointer v_object) {
	Header* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_HEADER));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_HEADER));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		header_unref (old);
	}
}


static void header_class_init (HeaderClass * klass) {
	header_parent_class = g_type_class_peek_parent (klass);
	HEADER_CLASS (klass)->finalize = header_finalize;
	g_type_class_add_private (klass, sizeof (HeaderPrivate));
}


static void header_instance_init (Header * self) {
	self->priv = HEADER_GET_PRIVATE (self);
	self->ref_count = 1;
}


static void header_finalize (Header* obj) {
	Header * self;
	self = HEADER (obj);
	_g_regex_unref0 (self->priv->key_value_regex);
	_g_free0 (self->status);
	_g_free0 (self->Date);
	_g_free0 (self->Server);
	_g_free0 (self->Location);
	_g_free0 (self->Content_Type);
	_g_free0 (self->Transfer_Encoding);
	_g_free0 (self->code);
	_g_free0 (self->version);
}


GType header_get_type (void) {
	static volatile gsize header_type_id__volatile = 0;
	if (g_once_init_enter (&header_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_header_init, value_header_free_value, value_header_copy_value, value_header_peek_pointer, "p", value_header_collect_value, "p", value_header_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (HeaderClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) header_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Header), 0, (GInstanceInitFunc) header_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType header_type_id;
		header_type_id = g_type_register_fundamental (g_type_fundamental_next (), "Header", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&header_type_id__volatile, header_type_id);
	}
	return header_type_id__volatile;
}


gpointer header_ref (gpointer instance) {
	Header* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void header_unref (gpointer instance) {
	Header* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		HEADER_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


Downloader* downloader_construct (GType object_type, const gchar* url, const gchar* local_file, gint* throttler) {
	Downloader * self = NULL;
	DownloaderInfo _tmp0_ = {0};
	DownloaderInfo _tmp1_;
	gint* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	g_return_val_if_fail (url != NULL, NULL);
	self = (Downloader*) g_object_new (object_type, NULL);
	self->priv->debug = FALSE;
	memset (&_tmp0_, 0, sizeof (DownloaderInfo));
	_tmp0_.length = (guint64) 0;
	downloader_info_destroy (&self->priv->dli);
	self->priv->dli = _tmp0_;
	_tmp1_ = self->priv->dli;
	self->priv->borked = FALSE;
	self->length = (guint64) 0;
	self->priv->dl_length = 0;
	_tmp2_ = throttler;
	self->priv->throttler = *_tmp2_;
	self->priv->download_complete = FALSE;
	self->priv->downloader_finished = FALSE;
	_tmp3_ = url;
	_tmp4_ = g_strdup (_tmp3_);
	_g_free0 (self->priv->url);
	self->priv->url = _tmp4_;
	self->priv->kill_download = FALSE;
	_tmp5_ = local_file;
	if (_tmp5_ != NULL) {
		const gchar* _tmp6_;
		gchar* _tmp7_;
		_tmp6_ = local_file;
		_tmp7_ = g_strdup (_tmp6_);
		_g_free0 (self->local_file_path);
		self->local_file_path = _tmp7_;
	}
	return self;
}


Downloader* downloader_new (const gchar* url, const gchar* local_file, gint* throttler) {
	return downloader_construct (TYPE_DOWNLOADER, url, local_file, throttler);
}


void downloader_set_debug (Downloader* self, gboolean val) {
	gboolean _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = val;
	self->priv->debug = _tmp0_;
}


gboolean downloader_is_borked (Downloader* self) {
	gboolean result = FALSE;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->borked;
	result = _tmp0_;
	return result;
}


void downloader_kill (Downloader* self) {
	g_return_if_fail (self != NULL);
	self->priv->kill_download = TRUE;
}


void downloader_get_info (Downloader* self, DownloaderInfo* result) {
	DownloaderInfo _tmp0_;
	DownloaderInfo _tmp1_ = {0};
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->dli;
	downloader_info_copy (&_tmp0_, &_tmp1_);
	*result = _tmp1_;
	return;
}


void downloader_set_feed_title (Downloader* self, const gchar* feed_title) {
	const gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (feed_title != NULL);
	_tmp0_ = feed_title;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->dli.feed_title);
	self->priv->dli.feed_title = _tmp1_;
}


void downloader_set_title (Downloader* self, const gchar* title) {
	const gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (title != NULL);
	_tmp0_ = title;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->dli.title);
	self->priv->dli.title = _tmp1_;
}


void downloader_set_id (Downloader* self, const gchar* id) {
	const gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (id != NULL);
	_tmp0_ = id;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->dli.id);
	self->priv->dli.id = _tmp1_;
}


void downloader_run (Downloader* self) {
	const gchar* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->url;
	downloader_download (self, _tmp0_, 0);
}


static gpointer _downloader_thread_download_gthread_func (gpointer self) {
	gpointer result;
	result = downloader_thread_download (self);
	return result;
}


void downloader_run_async (Downloader* self) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	{
		g_thread_create (_downloader_thread_download_gthread_func, self, FALSE, &_inner_error_);
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == G_THREAD_ERROR) {
				goto __catch12_g_thread_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	goto __finally12;
	__catch12_g_thread_error:
	{
		GError* e = NULL;
		FILE* _tmp0_;
		GError* _tmp1_;
		const gchar* _tmp2_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp0_ = stderr;
		_tmp1_ = e;
		_tmp2_ = _tmp1_->message;
		fprintf (_tmp0_, "%s\n", _tmp2_);
		_g_error_free0 (e);
	}
	__finally12:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


static void* downloader_thread_download (Downloader* self) {
	void* result = NULL;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->url;
	downloader_download (self, _tmp0_, 0);
	result = NULL;
	return result;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void _g_object_unref0_ (gpointer var) {
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
}


static void _g_list_free__g_object_unref0_ (GList* self) {
	g_list_foreach (self, (GFunc) _g_object_unref0_, NULL);
	g_list_free (self);
}


static guint8* string_get_data (const gchar* self, int* result_length1) {
	guint8* result;
	guint8* res;
	gint res_length1;
	gint _res_size_;
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	guint8* _tmp3_;
	gint _tmp3__length1;
	guint8* _tmp4_;
	gint _tmp4__length1;
	g_return_val_if_fail (self != NULL, NULL);
	res = (guint8*) self;
	res_length1 = -1;
	_res_size_ = res_length1;
	_tmp0_ = strlen (self);
	_tmp1_ = _tmp0_;
	res_length1 = (gint) _tmp1_;
	_tmp2_ = res_length1;
	_tmp3_ = res;
	_tmp3__length1 = res_length1;
	_tmp4_ = _tmp3_;
	_tmp4__length1 = _tmp3__length1;
	if (result_length1) {
		*result_length1 = _tmp4__length1;
	}
	result = _tmp4_;
	return result;
}


static gchar* string_strip (const gchar* self) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _result_;
	const gchar* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup (self);
	_result_ = _tmp0_;
	_tmp1_ = _result_;
	g_strstrip (_tmp1_);
	result = _result_;
	return result;
}


static void _vala_array_add12 (guint8** array, int* length, int* size, guint8 value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (guint8, *array, *size);
	}
	(*array)[(*length)++] = value;
}


static void downloader_download (Downloader* self, const gchar* remote, gint redirects) {
	Header* _tmp0_;
	Header* header;
	ParsedURL* _tmp1_;
	ParsedURL* pu;
	const gchar* _tmp9_;
	const gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* partial_file;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (remote != NULL);
	_tmp0_ = header_new ();
	header = _tmp0_;
	_tmp1_ = parsed_url_new ();
	pu = _tmp1_;
	{
		ParsedURL* _tmp2_;
		const gchar* _tmp3_;
		_tmp2_ = pu;
		_tmp3_ = remote;
		parsed_url_parse (_tmp2_, _tmp3_, &_inner_error_);
		if (_inner_error_ != NULL) {
			goto __catch13_g_error;
		}
	}
	goto __finally13;
	__catch13_g_error:
	{
		GError* e = NULL;
		FILE* _tmp4_;
		GError* _tmp5_;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp4_ = stderr;
		_tmp5_ = e;
		_tmp6_ = _tmp5_->message;
		_tmp7_ = g_strconcat (_tmp6_, "\n", NULL);
		_tmp8_ = _tmp7_;
		fprintf (_tmp4_, "%s", _tmp8_);
		_g_free0 (_tmp8_);
		g_signal_emit_by_name (self, "finished");
		_g_error_free0 (e);
		_parsed_url_unref0 (pu);
		_header_unref0 (header);
		return;
	}
	__finally13:
	if (_inner_error_ != NULL) {
		_parsed_url_unref0 (pu);
		_header_unref0 (header);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	_tmp9_ = self->local_file_path;
	if (_tmp9_ == NULL) {
		ParsedURL* _tmp10_;
		const gchar* _tmp11_;
		gchar* _tmp12_ = NULL;
		_tmp10_ = pu;
		_tmp11_ = _tmp10_->request;
		_tmp12_ = g_path_get_basename (_tmp11_);
		_g_free0 (self->local_file_path);
		self->local_file_path = _tmp12_;
	}
	_tmp13_ = self->local_file_path;
	_tmp14_ = g_strconcat (_tmp13_, ".partial", NULL);
	partial_file = _tmp14_;
	{
		GResolver* _tmp15_ = NULL;
		GResolver* resolver;
		GResolver* _tmp16_;
		ParsedURL* _tmp17_;
		const gchar* _tmp18_;
		GList* _tmp19_ = NULL;
		GList* addresses;
		GList* _tmp20_;
		gconstpointer _tmp21_ = NULL;
		GInetAddress* _tmp22_;
		GInetAddress* address;
		GSocketClient* _tmp23_;
		GSocketClient* client;
		GSocketClient* _tmp24_;
		GInetAddress* _tmp25_;
		ParsedURL* _tmp26_;
		gint _tmp27_;
		GInetSocketAddress* _tmp28_;
		GInetSocketAddress* _tmp29_;
		GSocketConnection* _tmp30_ = NULL;
		GSocketConnection* _tmp31_;
		GSocketConnection* conn;
		gchar* _tmp32_;
		gchar* agent;
		ParsedURL* _tmp33_;
		const gchar* _tmp34_;
		ParsedURL* _tmp43_;
		const gchar* _tmp44_;
		gchar* _tmp45_ = NULL;
		gchar* message;
		const gchar* _tmp46_;
		ParsedURL* _tmp47_;
		const gchar* _tmp48_;
		gchar* _tmp49_ = NULL;
		gchar* _tmp50_;
		gchar* _tmp51_;
		const gchar* _tmp52_;
		const gchar* _tmp53_;
		gchar* _tmp54_ = NULL;
		gchar* _tmp55_;
		gchar* _tmp56_;
		const gchar* _tmp57_;
		gchar* _tmp58_;
		const gchar* _tmp59_;
		gchar* _tmp60_;
		GSocketConnection* _tmp61_;
		GOutputStream* _tmp62_;
		GOutputStream* _tmp63_;
		const gchar* _tmp64_;
		guint8* _tmp65_;
		gint _tmp65__length1;
		guint8* _tmp66_;
		gint _tmp66__length1;
		gboolean _tmp67_;
		GSocketConnection* _tmp73_;
		GInputStream* _tmp74_;
		GInputStream* _tmp75_;
		GDataInputStream* _tmp76_;
		GDataInputStream* response;
		gsize length;
		gchar* line = NULL;
		gboolean _tmp92_ = FALSE;
		Header* _tmp93_;
		const gchar* _tmp94_;
		gboolean _tmp97_;
		const gchar* _tmp108_;
		GFile* _tmp109_ = NULL;
		GFile* file;
		GFile* _tmp110_;
		gboolean _tmp111_ = FALSE;
		GFile* _tmp113_;
		GFileOutputStream* _tmp114_ = NULL;
		GFileOutputStream* _tmp115_;
		GFileOutputStream* _tmp116_;
		GDataOutputStream* _tmp117_;
		GDataOutputStream* _tmp118_;
		GDataOutputStream* dos;
		gsize len = 0UL;
		guint8* _tmp119_ = NULL;
		guint8* buffer;
		gint buffer_length1;
		gint _buffer_size_;
		Header* _tmp120_;
		guint64 _tmp121_;
		const gchar* _tmp205_;
		const gchar* _tmp206_;
		_tmp15_ = g_resolver_get_default ();
		resolver = _tmp15_;
		_tmp16_ = resolver;
		_tmp17_ = pu;
		_tmp18_ = _tmp17_->host;
		_tmp19_ = g_resolver_lookup_by_name (_tmp16_, _tmp18_, NULL, &_inner_error_);
		addresses = _tmp19_;
		if (_inner_error_ != NULL) {
			_g_object_unref0 (resolver);
			goto __catch14_g_error;
		}
		_tmp20_ = addresses;
		_tmp21_ = g_list_nth_data (_tmp20_, (guint) 0);
		_tmp22_ = _g_object_ref0 ((GInetAddress*) _tmp21_);
		address = _tmp22_;
		_tmp23_ = g_socket_client_new ();
		client = _tmp23_;
		_tmp24_ = client;
		_tmp25_ = address;
		_tmp26_ = pu;
		_tmp27_ = _tmp26_->port;
		_tmp28_ = (GInetSocketAddress*) g_inet_socket_address_new (_tmp25_, (guint16) _tmp27_);
		_tmp29_ = _tmp28_;
		_tmp30_ = g_socket_client_connect (_tmp24_, (GSocketConnectable*) _tmp29_, NULL, &_inner_error_);
		_tmp31_ = _tmp30_;
		_g_object_unref0 (_tmp29_);
		conn = _tmp31_;
		if (_inner_error_ != NULL) {
			_g_object_unref0 (client);
			_g_object_unref0 (address);
			__g_list_free__g_object_unref0_0 (addresses);
			_g_object_unref0 (resolver);
			goto __catch14_g_error;
		}
		_tmp32_ = g_strdup ("MuttonChop/0.1 http://www.jezra.net/project/muttonchop");
		agent = _tmp32_;
		_tmp33_ = pu;
		_tmp34_ = _tmp33_->query;
		if (g_strcmp0 (_tmp34_, "") != 0) {
			ParsedURL* _tmp35_;
			ParsedURL* _tmp36_;
			const gchar* _tmp37_;
			ParsedURL* _tmp38_;
			const gchar* _tmp39_;
			gchar* _tmp40_;
			gchar* _tmp41_;
			gchar* _tmp42_;
			_tmp35_ = pu;
			_tmp36_ = pu;
			_tmp37_ = _tmp36_->request;
			_tmp38_ = pu;
			_tmp39_ = _tmp38_->query;
			_tmp40_ = g_strconcat ("?", _tmp39_, NULL);
			_tmp41_ = _tmp40_;
			_tmp42_ = g_strconcat (_tmp37_, _tmp41_, NULL);
			_g_free0 (_tmp36_->request);
			_tmp36_->request = _tmp42_;
			_g_free0 (_tmp41_);
		}
		_tmp43_ = pu;
		_tmp44_ = _tmp43_->request;
		_tmp45_ = g_strdup_printf ("GET %s HTTP/1.1\r\n", _tmp44_);
		message = _tmp45_;
		_tmp46_ = message;
		_tmp47_ = pu;
		_tmp48_ = _tmp47_->host;
		_tmp49_ = g_strdup_printf ("Host: %s\r\n", _tmp48_);
		_tmp50_ = _tmp49_;
		_tmp51_ = g_strconcat (_tmp46_, _tmp50_, NULL);
		_g_free0 (message);
		message = _tmp51_;
		_g_free0 (_tmp50_);
		_tmp52_ = message;
		_tmp53_ = agent;
		_tmp54_ = g_strdup_printf ("User-Agent: %s\r\n", _tmp53_);
		_tmp55_ = _tmp54_;
		_tmp56_ = g_strconcat (_tmp52_, _tmp55_, NULL);
		_g_free0 (message);
		message = _tmp56_;
		_g_free0 (_tmp55_);
		_tmp57_ = message;
		_tmp58_ = g_strconcat (_tmp57_, "Accept-Encoding: identify\r\n", NULL);
		_g_free0 (message);
		message = _tmp58_;
		_tmp59_ = message;
		_tmp60_ = g_strconcat (_tmp59_, "\r\n", NULL);
		_g_free0 (message);
		message = _tmp60_;
		_tmp61_ = conn;
		_tmp62_ = g_io_stream_get_output_stream ((GIOStream*) _tmp61_);
		_tmp63_ = _tmp62_;
		_tmp64_ = message;
		_tmp65_ = string_get_data (_tmp64_, &_tmp65__length1);
		_tmp66_ = _tmp65_;
		_tmp66__length1 = _tmp65__length1;
		g_output_stream_write (_tmp63_, _tmp66_, (gsize) _tmp66__length1, NULL, &_inner_error_);
		if (_inner_error_ != NULL) {
			_g_free0 (message);
			_g_free0 (agent);
			_g_object_unref0 (conn);
			_g_object_unref0 (client);
			_g_object_unref0 (address);
			__g_list_free__g_object_unref0_0 (addresses);
			_g_object_unref0 (resolver);
			goto __catch14_g_error;
		}
		_tmp67_ = self->priv->debug;
		if (_tmp67_) {
			FILE* _tmp68_;
			const gchar* _tmp69_;
			const gchar* _tmp70_ = NULL;
			gchar* _tmp71_ = NULL;
			gchar* _tmp72_;
			_tmp68_ = stdout;
			_tmp69_ = message;
			_tmp70_ = string_to_string (_tmp69_);
			_tmp71_ = g_strconcat (_tmp70_, "\n", NULL);
			_tmp72_ = _tmp71_;
			fprintf (_tmp68_, "%s", _tmp72_);
			_g_free0 (_tmp72_);
		}
		_tmp73_ = conn;
		_tmp74_ = g_io_stream_get_input_stream ((GIOStream*) _tmp73_);
		_tmp75_ = _tmp74_;
		_tmp76_ = g_data_input_stream_new (_tmp75_);
		response = _tmp76_;
		length = (gsize) 0;
		{
			gboolean _tmp77_;
			_tmp77_ = TRUE;
			while (TRUE) {
				gboolean _tmp78_;
				GDataInputStream* _tmp80_;
				gsize _tmp81_ = 0UL;
				gchar* _tmp82_ = NULL;
				gchar* _tmp83_;
				gboolean _tmp84_;
				Header* _tmp90_;
				const gchar* _tmp91_;
				_tmp78_ = _tmp77_;
				if (!_tmp78_) {
					gsize _tmp79_;
					_tmp79_ = length;
					if (!(_tmp79_ > ((gsize) 1))) {
						break;
					}
				}
				_tmp77_ = FALSE;
				_tmp80_ = response;
				_tmp82_ = g_data_input_stream_read_line (_tmp80_, &_tmp81_, NULL, &_inner_error_);
				length = _tmp81_;
				_tmp83_ = _tmp82_;
				if (_inner_error_ != NULL) {
					_g_free0 (line);
					_g_object_unref0 (response);
					_g_free0 (message);
					_g_free0 (agent);
					_g_object_unref0 (conn);
					_g_object_unref0 (client);
					_g_object_unref0 (address);
					__g_list_free__g_object_unref0_0 (addresses);
					_g_object_unref0 (resolver);
					goto __catch14_g_error;
				}
				_g_free0 (line);
				line = _tmp83_;
				_tmp84_ = self->priv->debug;
				if (_tmp84_) {
					FILE* _tmp85_;
					const gchar* _tmp86_;
					const gchar* _tmp87_ = NULL;
					gchar* _tmp88_ = NULL;
					gchar* _tmp89_;
					_tmp85_ = stdout;
					_tmp86_ = line;
					_tmp87_ = string_to_string (_tmp86_);
					_tmp88_ = g_strconcat (_tmp87_, "\n", NULL);
					_tmp89_ = _tmp88_;
					fprintf (_tmp85_, "%s", _tmp89_);
					_g_free0 (_tmp89_);
				}
				_tmp90_ = header;
				_tmp91_ = line;
				header_add_value (_tmp90_, _tmp91_);
			}
		}
		_tmp93_ = header;
		_tmp94_ = _tmp93_->code;
		if (g_strcmp0 (_tmp94_, "301") == 0) {
			_tmp92_ = TRUE;
		} else {
			Header* _tmp95_;
			const gchar* _tmp96_;
			_tmp95_ = header;
			_tmp96_ = _tmp95_->code;
			_tmp92_ = g_strcmp0 (_tmp96_, "302") == 0;
		}
		_tmp97_ = _tmp92_;
		if (_tmp97_) {
			gint _tmp98_;
			_tmp98_ = redirects;
			if (_tmp98_ >= 10) {
				FILE* _tmp99_;
				_tmp99_ = stderr;
				fprintf (_tmp99_, "Error: Too many Redirects\n");
				g_signal_emit_by_name (self, "finished");
				_g_free0 (line);
				_g_object_unref0 (response);
				_g_free0 (message);
				_g_free0 (agent);
				_g_object_unref0 (conn);
				_g_object_unref0 (client);
				_g_object_unref0 (address);
				__g_list_free__g_object_unref0_0 (addresses);
				_g_object_unref0 (resolver);
				_g_free0 (partial_file);
				_parsed_url_unref0 (pu);
				_header_unref0 (header);
				return;
			} else {
				FILE* _tmp100_;
				gint _tmp101_;
				Header* _tmp102_;
				const gchar* _tmp103_;
				gint _tmp104_;
				Header* _tmp105_;
				const gchar* _tmp106_;
				gint _tmp107_;
				_tmp100_ = stdout;
				_tmp101_ = redirects;
				_tmp102_ = header;
				_tmp103_ = _tmp102_->Location;
				fprintf (_tmp100_, "Redirect %d: %s\n", _tmp101_, _tmp103_);
				_tmp104_ = redirects;
				redirects = _tmp104_ + 1;
				_tmp105_ = header;
				_tmp106_ = _tmp105_->Location;
				_tmp107_ = redirects;
				downloader_download (self, _tmp106_, _tmp107_);
				_g_free0 (line);
				_g_object_unref0 (response);
				_g_free0 (message);
				_g_free0 (agent);
				_g_object_unref0 (conn);
				_g_object_unref0 (client);
				_g_object_unref0 (address);
				__g_list_free__g_object_unref0_0 (addresses);
				_g_object_unref0 (resolver);
				_g_free0 (partial_file);
				_parsed_url_unref0 (pu);
				_header_unref0 (header);
				return;
			}
		}
		_tmp108_ = partial_file;
		_tmp109_ = g_file_new_for_path (_tmp108_);
		file = _tmp109_;
		_tmp110_ = file;
		_tmp111_ = g_file_query_exists (_tmp110_, NULL);
		if (_tmp111_) {
			GFile* _tmp112_;
			_tmp112_ = file;
			g_file_delete (_tmp112_, NULL, &_inner_error_);
			if (_inner_error_ != NULL) {
				_g_object_unref0 (file);
				_g_free0 (line);
				_g_object_unref0 (response);
				_g_free0 (message);
				_g_free0 (agent);
				_g_object_unref0 (conn);
				_g_object_unref0 (client);
				_g_object_unref0 (address);
				__g_list_free__g_object_unref0_0 (addresses);
				_g_object_unref0 (resolver);
				goto __catch14_g_error;
			}
		}
		_tmp113_ = file;
		_tmp114_ = g_file_create (_tmp113_, G_FILE_CREATE_REPLACE_DESTINATION, NULL, &_inner_error_);
		_tmp115_ = _tmp114_;
		if (_inner_error_ != NULL) {
			_g_object_unref0 (file);
			_g_free0 (line);
			_g_object_unref0 (response);
			_g_free0 (message);
			_g_free0 (agent);
			_g_object_unref0 (conn);
			_g_object_unref0 (client);
			_g_object_unref0 (address);
			__g_list_free__g_object_unref0_0 (addresses);
			_g_object_unref0 (resolver);
			goto __catch14_g_error;
		}
		_tmp116_ = _tmp115_;
		_tmp117_ = g_data_output_stream_new ((GOutputStream*) _tmp116_);
		_tmp118_ = _tmp117_;
		_g_object_unref0 (_tmp116_);
		dos = _tmp118_;
		self->bytes_read = (guint64) 0;
		_tmp119_ = g_new0 (guint8, 0);
		buffer = _tmp119_;
		buffer_length1 = 0;
		_buffer_size_ = buffer_length1;
		_tmp120_ = header;
		_tmp121_ = _tmp120_->Content_Length;
		if (_tmp121_ > ((guint64) 0)) {
			Header* _tmp122_;
			guint64 _tmp123_;
			guint64 bytes_to_read = 0ULL;
			guint64 bytes_remaining = 0ULL;
			_tmp122_ = header;
			_tmp123_ = _tmp122_->Content_Length;
			self->priv->dli.length = _tmp123_;
			while (TRUE) {
				gboolean _tmp124_ = FALSE;
				GSocketConnection* _tmp125_;
				gboolean _tmp126_ = FALSE;
				gboolean _tmp130_;
				Header* _tmp131_;
				guint64 _tmp132_;
				guint64 _tmp133_;
				guint64 _tmp134_ = 0ULL;
				guint64 _tmp135_;
				guint64 _tmp137_;
				guint64 _tmp138_;
				gint _tmp139_ = 0;
				GDataInputStream* _tmp140_;
				guint8* _tmp141_;
				gint _tmp141__length1;
				gssize _tmp142_ = 0L;
				gssize _tmp143_;
				guint64 _tmp144_;
				gsize _tmp145_;
				guint64 _tmp146_;
				glong written;
				gboolean _tmp156_;
				_tmp125_ = conn;
				_tmp126_ = g_io_stream_is_closed ((GIOStream*) _tmp125_);
				if (!_tmp126_) {
					guint64 _tmp127_;
					Header* _tmp128_;
					guint64 _tmp129_;
					_tmp127_ = self->bytes_read;
					_tmp128_ = header;
					_tmp129_ = _tmp128_->Content_Length;
					_tmp124_ = _tmp127_ < _tmp129_;
				} else {
					_tmp124_ = FALSE;
				}
				_tmp130_ = _tmp124_;
				if (!_tmp130_) {
					break;
				}
				_tmp131_ = header;
				_tmp132_ = _tmp131_->Content_Length;
				_tmp133_ = self->bytes_read;
				bytes_remaining = _tmp132_ - _tmp133_;
				_tmp135_ = bytes_remaining;
				if (_tmp135_ > ((guint64) 1028)) {
					_tmp134_ = (guint64) 1028;
				} else {
					guint64 _tmp136_;
					_tmp136_ = bytes_remaining;
					_tmp134_ = _tmp136_;
				}
				_tmp137_ = _tmp134_;
				bytes_to_read = _tmp137_;
				_tmp138_ = bytes_to_read;
				_tmp139_ = (gint) _tmp138_;
				buffer = g_renew (guint8, buffer, (gint) _tmp138_);
				(_tmp139_ > buffer_length1) ? memset (buffer + buffer_length1, 0, sizeof (guint8) * (_tmp139_ - buffer_length1)) : NULL;
				buffer_length1 = _tmp139_;
				_buffer_size_ = _tmp139_;
				_tmp140_ = response;
				_tmp141_ = buffer;
				_tmp141__length1 = buffer_length1;
				_tmp142_ = g_input_stream_read ((GInputStream*) _tmp140_, _tmp141_, (gsize) _tmp141__length1, NULL, &_inner_error_);
				_tmp143_ = _tmp142_;
				if (_inner_error_ != NULL) {
					buffer = (g_free (buffer), NULL);
					_g_object_unref0 (dos);
					_g_object_unref0 (file);
					_g_free0 (line);
					_g_object_unref0 (response);
					_g_free0 (message);
					_g_free0 (agent);
					_g_object_unref0 (conn);
					_g_object_unref0 (client);
					_g_object_unref0 (address);
					__g_list_free__g_object_unref0_0 (addresses);
					_g_object_unref0 (resolver);
					goto __catch14_g_error;
				}
				len = (gsize) _tmp143_;
				_tmp144_ = self->bytes_read;
				_tmp145_ = len;
				self->bytes_read = _tmp144_ + _tmp145_;
				_tmp146_ = self->bytes_read;
				self->priv->dli.bytes_downloaded = _tmp146_;
				written = (glong) 0;
				while (TRUE) {
					glong _tmp147_;
					gsize _tmp148_;
					GDataOutputStream* _tmp149_;
					guint8* _tmp150_;
					gint _tmp150__length1;
					glong _tmp151_;
					gsize _tmp152_;
					gssize _tmp153_ = 0L;
					gssize _tmp154_;
					glong _tmp155_;
					_tmp147_ = written;
					_tmp148_ = len;
					if (!(((gsize) _tmp147_) < _tmp148_)) {
						break;
					}
					_tmp149_ = dos;
					_tmp150_ = buffer;
					_tmp150__length1 = buffer_length1;
					_tmp151_ = written;
					_tmp152_ = len;
					_tmp153_ = g_output_stream_write ((GOutputStream*) _tmp149_, _tmp150_ + _tmp151_, (gsize) (_tmp152_ - _tmp151_), NULL, &_inner_error_);
					_tmp154_ = _tmp153_;
					if (_inner_error_ != NULL) {
						buffer = (g_free (buffer), NULL);
						_g_object_unref0 (dos);
						_g_object_unref0 (file);
						_g_free0 (line);
						_g_object_unref0 (response);
						_g_free0 (message);
						_g_free0 (agent);
						_g_object_unref0 (conn);
						_g_object_unref0 (client);
						_g_object_unref0 (address);
						__g_list_free__g_object_unref0_0 (addresses);
						_g_object_unref0 (resolver);
						goto __catch14_g_error;
					}
					_tmp155_ = written;
					written = _tmp155_ + _tmp154_;
				}
				_tmp156_ = self->priv->kill_download;
				if (_tmp156_) {
					GSocketConnection* _tmp157_;
					const gchar* _tmp158_;
					self->priv->downloader_finished = TRUE;
					_tmp157_ = conn;
					g_io_stream_close ((GIOStream*) _tmp157_, NULL, &_inner_error_);
					if (_inner_error_ != NULL) {
						buffer = (g_free (buffer), NULL);
						_g_object_unref0 (dos);
						_g_object_unref0 (file);
						_g_free0 (line);
						_g_object_unref0 (response);
						_g_free0 (message);
						_g_free0 (agent);
						_g_object_unref0 (conn);
						_g_object_unref0 (client);
						_g_object_unref0 (address);
						__g_list_free__g_object_unref0_0 (addresses);
						_g_object_unref0 (resolver);
						goto __catch14_g_error;
					}
					_tmp158_ = partial_file;
					g_remove (_tmp158_);
					g_signal_emit_by_name (self, "finished");
					buffer = (g_free (buffer), NULL);
					_g_object_unref0 (dos);
					_g_object_unref0 (file);
					_g_free0 (line);
					_g_object_unref0 (response);
					_g_free0 (message);
					_g_free0 (agent);
					_g_object_unref0 (conn);
					_g_object_unref0 (client);
					_g_object_unref0 (address);
					__g_list_free__g_object_unref0_0 (addresses);
					_g_object_unref0 (resolver);
					_g_free0 (partial_file);
					_parsed_url_unref0 (pu);
					_header_unref0 (header);
					return;
				}
			}
		} else {
			Header* _tmp159_;
			const gchar* _tmp160_;
			_tmp159_ = header;
			_tmp160_ = _tmp159_->Transfer_Encoding;
			if (g_strcmp0 (_tmp160_, "chunked") == 0) {
				gboolean _tmp161_;
				gboolean read;
				gchar* length_line = NULL;
				gchar* data_line = NULL;
				gint read_length = 0;
				_tmp161_ = self->priv->debug;
				if (_tmp161_) {
					FILE* _tmp162_;
					_tmp162_ = stdout;
					fprintf (_tmp162_, "Chunked Encoding\n");
				}
				read = TRUE;
				while (TRUE) {
					gboolean _tmp163_ = FALSE;
					GSocketConnection* _tmp164_;
					gboolean _tmp165_ = FALSE;
					gboolean _tmp167_;
					GDataInputStream* _tmp168_;
					gsize _tmp169_ = 0UL;
					gchar* _tmp170_ = NULL;
					gchar* _tmp171_;
					gchar* _tmp172_;
					gchar* _tmp173_ = NULL;
					const gchar* _tmp174_;
					gint _tmp175_ = 0;
					gboolean _tmp176_;
					gint _tmp179_;
					guint8* _tmp180_ = NULL;
					GDataOutputStream* _tmp190_;
					guint8* _tmp191_;
					gint _tmp191__length1;
					GDataInputStream* _tmp192_;
					gsize _tmp193_ = 0UL;
					gchar* _tmp194_ = NULL;
					gchar* _tmp195_;
					gboolean _tmp196_;
					_tmp164_ = conn;
					_tmp165_ = g_io_stream_is_closed ((GIOStream*) _tmp164_);
					if (!_tmp165_) {
						gboolean _tmp166_;
						_tmp166_ = read;
						_tmp163_ = _tmp166_;
					} else {
						_tmp163_ = FALSE;
					}
					_tmp167_ = _tmp163_;
					if (!_tmp167_) {
						break;
					}
					_tmp168_ = response;
					_tmp170_ = g_data_input_stream_read_line (_tmp168_, &_tmp169_, NULL, &_inner_error_);
					len = _tmp169_;
					_tmp171_ = _tmp170_;
					if (_inner_error_ != NULL) {
						_g_free0 (data_line);
						_g_free0 (length_line);
						buffer = (g_free (buffer), NULL);
						_g_object_unref0 (dos);
						_g_object_unref0 (file);
						_g_free0 (line);
						_g_object_unref0 (response);
						_g_free0 (message);
						_g_free0 (agent);
						_g_object_unref0 (conn);
						_g_object_unref0 (client);
						_g_object_unref0 (address);
						__g_list_free__g_object_unref0_0 (addresses);
						_g_object_unref0 (resolver);
						goto __catch14_g_error;
					}
					_tmp172_ = _tmp171_;
					_tmp173_ = string_strip (_tmp172_);
					_g_free0 (length_line);
					length_line = _tmp173_;
					_g_free0 (_tmp172_);
					_tmp174_ = length_line;
					_tmp175_ = downloader_hextoint (self, _tmp174_);
					read_length = _tmp175_;
					_tmp176_ = self->priv->debug;
					if (_tmp176_) {
						FILE* _tmp177_;
						gint _tmp178_;
						_tmp177_ = stdout;
						_tmp178_ = read_length;
						fprintf (_tmp177_, "line length: %d\n", _tmp178_);
					}
					_tmp179_ = read_length;
					if (_tmp179_ == 0) {
						read = FALSE;
						break;
					}
					_tmp180_ = g_new0 (guint8, 0);
					buffer = (g_free (buffer), NULL);
					buffer = _tmp180_;
					buffer_length1 = 0;
					_buffer_size_ = buffer_length1;
					{
						gint i;
						i = 0;
						{
							gboolean _tmp181_;
							_tmp181_ = TRUE;
							while (TRUE) {
								gboolean _tmp182_;
								gint _tmp184_;
								gint _tmp185_;
								GDataInputStream* _tmp186_;
								guint8 _tmp187_ = 0U;
								guint8 _tmp188_;
								guint8* _tmp189_;
								gint _tmp189__length1;
								_tmp182_ = _tmp181_;
								if (!_tmp182_) {
									gint _tmp183_;
									_tmp183_ = i;
									i = _tmp183_ + 1;
								}
								_tmp181_ = FALSE;
								_tmp184_ = i;
								_tmp185_ = read_length;
								if (!(_tmp184_ < _tmp185_)) {
									break;
								}
								_tmp186_ = response;
								_tmp187_ = g_data_input_stream_read_byte (_tmp186_, NULL, &_inner_error_);
								_tmp188_ = _tmp187_;
								if (_inner_error_ != NULL) {
									_g_free0 (data_line);
									_g_free0 (length_line);
									buffer = (g_free (buffer), NULL);
									_g_object_unref0 (dos);
									_g_object_unref0 (file);
									_g_free0 (line);
									_g_object_unref0 (response);
									_g_free0 (message);
									_g_free0 (agent);
									_g_object_unref0 (conn);
									_g_object_unref0 (client);
									_g_object_unref0 (address);
									__g_list_free__g_object_unref0_0 (addresses);
									_g_object_unref0 (resolver);
									goto __catch14_g_error;
								}
								_tmp189_ = buffer;
								_tmp189__length1 = buffer_length1;
								_vala_array_add12 (&buffer, &buffer_length1, &_buffer_size_, _tmp188_);
							}
						}
					}
					_tmp190_ = dos;
					_tmp191_ = buffer;
					_tmp191__length1 = buffer_length1;
					g_output_stream_write ((GOutputStream*) _tmp190_, _tmp191_, (gsize) _tmp191__length1, NULL, &_inner_error_);
					if (_inner_error_ != NULL) {
						_g_free0 (data_line);
						_g_free0 (length_line);
						buffer = (g_free (buffer), NULL);
						_g_object_unref0 (dos);
						_g_object_unref0 (file);
						_g_free0 (line);
						_g_object_unref0 (response);
						_g_free0 (message);
						_g_free0 (agent);
						_g_object_unref0 (conn);
						_g_object_unref0 (client);
						_g_object_unref0 (address);
						__g_list_free__g_object_unref0_0 (addresses);
						_g_object_unref0 (resolver);
						goto __catch14_g_error;
					}
					_tmp192_ = response;
					_tmp194_ = g_data_input_stream_read_line (_tmp192_, &_tmp193_, NULL, &_inner_error_);
					len = _tmp193_;
					_tmp195_ = _tmp194_;
					if (_inner_error_ != NULL) {
						_g_free0 (data_line);
						_g_free0 (length_line);
						buffer = (g_free (buffer), NULL);
						_g_object_unref0 (dos);
						_g_object_unref0 (file);
						_g_free0 (line);
						_g_object_unref0 (response);
						_g_free0 (message);
						_g_free0 (agent);
						_g_object_unref0 (conn);
						_g_object_unref0 (client);
						_g_object_unref0 (address);
						__g_list_free__g_object_unref0_0 (addresses);
						_g_object_unref0 (resolver);
						goto __catch14_g_error;
					}
					_g_free0 (data_line);
					data_line = _tmp195_;
					_tmp196_ = self->priv->kill_download;
					if (_tmp196_) {
						GSocketConnection* _tmp197_;
						const gchar* _tmp198_;
						self->priv->downloader_finished = TRUE;
						_tmp197_ = conn;
						g_io_stream_close ((GIOStream*) _tmp197_, NULL, &_inner_error_);
						if (_inner_error_ != NULL) {
							_g_free0 (data_line);
							_g_free0 (length_line);
							buffer = (g_free (buffer), NULL);
							_g_object_unref0 (dos);
							_g_object_unref0 (file);
							_g_free0 (line);
							_g_object_unref0 (response);
							_g_free0 (message);
							_g_free0 (agent);
							_g_object_unref0 (conn);
							_g_object_unref0 (client);
							_g_object_unref0 (address);
							__g_list_free__g_object_unref0_0 (addresses);
							_g_object_unref0 (resolver);
							goto __catch14_g_error;
						}
						_tmp198_ = partial_file;
						g_remove (_tmp198_);
						g_signal_emit_by_name (self, "finished");
						_g_free0 (data_line);
						_g_free0 (length_line);
						buffer = (g_free (buffer), NULL);
						_g_object_unref0 (dos);
						_g_object_unref0 (file);
						_g_free0 (line);
						_g_object_unref0 (response);
						_g_free0 (message);
						_g_free0 (agent);
						_g_object_unref0 (conn);
						_g_object_unref0 (client);
						_g_object_unref0 (address);
						__g_list_free__g_object_unref0_0 (addresses);
						_g_object_unref0 (resolver);
						_g_free0 (partial_file);
						_parsed_url_unref0 (pu);
						_header_unref0 (header);
						return;
					}
				}
				_g_free0 (data_line);
				_g_free0 (length_line);
			} else {
				while (TRUE) {
					GDataInputStream* _tmp199_;
					gboolean _tmp200_ = FALSE;
					GDataInputStream* _tmp201_;
					guint8 _tmp202_ = 0U;
					guint8 _tmp203_;
					GDataOutputStream* _tmp204_;
					_tmp199_ = response;
					_tmp200_ = g_input_stream_is_closed ((GInputStream*) _tmp199_);
					if (!(!_tmp200_)) {
						break;
					}
					_tmp201_ = response;
					_tmp202_ = g_data_input_stream_read_byte (_tmp201_, NULL, &_inner_error_);
					_tmp203_ = _tmp202_;
					if (_inner_error_ != NULL) {
						buffer = (g_free (buffer), NULL);
						_g_object_unref0 (dos);
						_g_object_unref0 (file);
						_g_free0 (line);
						_g_object_unref0 (response);
						_g_free0 (message);
						_g_free0 (agent);
						_g_object_unref0 (conn);
						_g_object_unref0 (client);
						_g_object_unref0 (address);
						__g_list_free__g_object_unref0_0 (addresses);
						_g_object_unref0 (resolver);
						goto __catch14_g_error;
					}
					_tmp204_ = dos;
					g_data_output_stream_put_byte (_tmp204_, _tmp203_, NULL, &_inner_error_);
					if (_inner_error_ != NULL) {
						buffer = (g_free (buffer), NULL);
						_g_object_unref0 (dos);
						_g_object_unref0 (file);
						_g_free0 (line);
						_g_object_unref0 (response);
						_g_free0 (message);
						_g_free0 (agent);
						_g_object_unref0 (conn);
						_g_object_unref0 (client);
						_g_object_unref0 (address);
						__g_list_free__g_object_unref0_0 (addresses);
						_g_object_unref0 (resolver);
						goto __catch14_g_error;
					}
				}
			}
		}
		_tmp205_ = partial_file;
		_tmp206_ = self->local_file_path;
		downloader_move_partial (self, _tmp205_, _tmp206_);
		g_signal_emit_by_name (self, "finished");
		buffer = (g_free (buffer), NULL);
		_g_object_unref0 (dos);
		_g_object_unref0 (file);
		_g_free0 (line);
		_g_object_unref0 (response);
		_g_free0 (message);
		_g_free0 (agent);
		_g_object_unref0 (conn);
		_g_object_unref0 (client);
		_g_object_unref0 (address);
		__g_list_free__g_object_unref0_0 (addresses);
		_g_object_unref0 (resolver);
	}
	goto __finally14;
	__catch14_g_error:
	{
		GError* e = NULL;
		gboolean _tmp207_ = FALSE;
		Header* _tmp208_;
		const gchar* _tmp209_;
		gboolean _tmp212_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp208_ = header;
		_tmp209_ = _tmp208_->version;
		if (g_strcmp0 (_tmp209_, "1.0") == 0) {
			Header* _tmp210_;
			guint64 _tmp211_;
			_tmp210_ = header;
			_tmp211_ = _tmp210_->Content_Length;
			_tmp207_ = !(_tmp211_ > ((guint64) 0));
		} else {
			_tmp207_ = FALSE;
		}
		_tmp212_ = _tmp207_;
		if (_tmp212_) {
			const gchar* _tmp213_;
			const gchar* _tmp214_;
			_tmp213_ = partial_file;
			_tmp214_ = self->local_file_path;
			downloader_move_partial (self, _tmp213_, _tmp214_);
		} else {
			FILE* _tmp215_;
			GError* _tmp216_;
			const gchar* _tmp217_;
			_tmp215_ = stderr;
			_tmp216_ = e;
			_tmp217_ = _tmp216_->message;
			fprintf (_tmp215_, "%s\n", _tmp217_);
		}
		g_signal_emit_by_name (self, "finished");
		_g_error_free0 (e);
		_g_free0 (partial_file);
		_parsed_url_unref0 (pu);
		_header_unref0 (header);
		return;
	}
	__finally14:
	if (_inner_error_ != NULL) {
		_g_free0 (partial_file);
		_parsed_url_unref0 (pu);
		_header_unref0 (header);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	_g_free0 (partial_file);
	_parsed_url_unref0 (pu);
	_header_unref0 (header);
}


static void downloader_move_partial (Downloader* self, const gchar* old_file, const gchar* new_file) {
	const gchar* _tmp0_;
	GFile* _tmp1_ = NULL;
	GFile* f;
	const gchar* _tmp2_;
	GFile* _tmp3_ = NULL;
	GFile* dest;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (old_file != NULL);
	g_return_if_fail (new_file != NULL);
	_tmp0_ = old_file;
	_tmp1_ = g_file_new_for_path (_tmp0_);
	f = _tmp1_;
	_tmp2_ = new_file;
	_tmp3_ = g_file_new_for_path (_tmp2_);
	dest = _tmp3_;
	{
		GFile* _tmp4_;
		GFile* _tmp5_;
		GFile* _tmp6_;
		_tmp4_ = f;
		_tmp5_ = dest;
		g_file_copy (_tmp4_, _tmp5_, G_FILE_COPY_OVERWRITE, NULL, NULL, NULL, &_inner_error_);
		if (_inner_error_ != NULL) {
			goto __catch15_g_error;
		}
		_tmp6_ = f;
		g_file_delete (_tmp6_, NULL, &_inner_error_);
		if (_inner_error_ != NULL) {
			goto __catch15_g_error;
		}
	}
	goto __finally15;
	__catch15_g_error:
	{
		GError* e = NULL;
		FILE* _tmp7_;
		GError* _tmp8_;
		const gchar* _tmp9_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp7_ = stderr;
		_tmp8_ = e;
		_tmp9_ = _tmp8_->message;
		fprintf (_tmp7_, "%s\n", _tmp9_);
		_g_error_free0 (e);
	}
	__finally15:
	if (_inner_error_ != NULL) {
		_g_object_unref0 (dest);
		_g_object_unref0 (f);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	self->priv->download_complete = TRUE;
	self->priv->downloader_finished = TRUE;
	_g_object_unref0 (dest);
	_g_object_unref0 (f);
}


gint downloader_hexval (Downloader* self, const gchar* c) {
	gint result = 0;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GQuark _tmp3_ = 0U;
	static GQuark _tmp2_label0 = 0;
	static GQuark _tmp2_label1 = 0;
	static GQuark _tmp2_label2 = 0;
	static GQuark _tmp2_label3 = 0;
	static GQuark _tmp2_label4 = 0;
	static GQuark _tmp2_label5 = 0;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (c != NULL, 0);
	_tmp0_ = c;
	_tmp1_ = _tmp0_;
	_tmp3_ = (NULL == _tmp1_) ? 0 : g_quark_from_string (_tmp1_);
	if (_tmp3_ == ((0 != _tmp2_label0) ? _tmp2_label0 : (_tmp2_label0 = g_quark_from_static_string ("a")))) {
		switch (0) {
			default:
			{
				result = 10;
				return result;
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label1) ? _tmp2_label1 : (_tmp2_label1 = g_quark_from_static_string ("b")))) {
		switch (0) {
			default:
			{
				result = 11;
				return result;
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label2) ? _tmp2_label2 : (_tmp2_label2 = g_quark_from_static_string ("c")))) {
		switch (0) {
			default:
			{
				result = 12;
				return result;
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label3) ? _tmp2_label3 : (_tmp2_label3 = g_quark_from_static_string ("d")))) {
		switch (0) {
			default:
			{
				result = 13;
				return result;
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label4) ? _tmp2_label4 : (_tmp2_label4 = g_quark_from_static_string ("e")))) {
		switch (0) {
			default:
			{
				result = 14;
				return result;
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label5) ? _tmp2_label5 : (_tmp2_label5 = g_quark_from_static_string ("f")))) {
		switch (0) {
			default:
			{
				result = 15;
				return result;
			}
		}
	} else {
		switch (0) {
			default:
			{
				const gchar* _tmp4_;
				gint _tmp5_ = 0;
				_tmp4_ = c;
				_tmp5_ = atoi (_tmp4_);
				result = _tmp5_;
				return result;
			}
		}
	}
}


gint downloader_hextoint (Downloader* self, const gchar* hex) {
	gint result = 0;
	const gchar* _tmp0_;
	gchar* _tmp1_ = NULL;
	gchar* dhex;
	gchar* c = NULL;
	gint val;
	gint calc = 0;
	gint mult = 0;
	const gchar* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gint hexlen;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (hex != NULL, 0);
	_tmp0_ = hex;
	_tmp1_ = g_utf8_strdown (_tmp0_, (gssize) (-1));
	dhex = _tmp1_;
	val = 0;
	_tmp2_ = hex;
	_tmp3_ = strlen (_tmp2_);
	_tmp4_ = _tmp3_;
	hexlen = _tmp4_;
	{
		gint i;
		i = 0;
		{
			gboolean _tmp5_;
			_tmp5_ = TRUE;
			while (TRUE) {
				gboolean _tmp6_;
				gint _tmp8_;
				gint _tmp9_;
				gint _tmp10_;
				gint _tmp11_;
				gint inv;
				const gchar* _tmp12_;
				gint _tmp13_;
				gint _tmp14_;
				gchar* _tmp15_ = NULL;
				const gchar* _tmp16_;
				gint _tmp17_ = 0;
				gint cint;
				gint _tmp24_;
				gint _tmp25_;
				gint _tmp26_;
				gint _tmp27_;
				_tmp6_ = _tmp5_;
				if (!_tmp6_) {
					gint _tmp7_;
					_tmp7_ = i;
					i = _tmp7_ + 1;
				}
				_tmp5_ = FALSE;
				_tmp8_ = i;
				_tmp9_ = hexlen;
				if (!(_tmp8_ < _tmp9_)) {
					break;
				}
				_tmp10_ = hexlen;
				_tmp11_ = i;
				inv = (_tmp10_ - 1) - _tmp11_;
				_tmp12_ = dhex;
				_tmp13_ = inv;
				_tmp14_ = inv;
				_tmp15_ = string_slice (_tmp12_, (glong) _tmp13_, (glong) (_tmp14_ + 1));
				_g_free0 (c);
				c = _tmp15_;
				_tmp16_ = c;
				_tmp17_ = downloader_hexval (self, _tmp16_);
				cint = _tmp17_;
				mult = 1;
				{
					gint j;
					j = 0;
					{
						gboolean _tmp18_;
						_tmp18_ = TRUE;
						while (TRUE) {
							gboolean _tmp19_;
							gint _tmp21_;
							gint _tmp22_;
							gint _tmp23_;
							_tmp19_ = _tmp18_;
							if (!_tmp19_) {
								gint _tmp20_;
								_tmp20_ = j;
								j = _tmp20_ + 1;
							}
							_tmp18_ = FALSE;
							_tmp21_ = j;
							_tmp22_ = i;
							if (!(_tmp21_ < _tmp22_)) {
								break;
							}
							_tmp23_ = mult;
							mult = _tmp23_ * 16;
						}
					}
				}
				_tmp24_ = cint;
				_tmp25_ = mult;
				calc = _tmp24_ * _tmp25_;
				_tmp26_ = val;
				_tmp27_ = calc;
				val = _tmp26_ + _tmp27_;
			}
		}
	}
	result = val;
	_g_free0 (c);
	_g_free0 (dhex);
	return result;
}


static void downloader_class_init (DownloaderClass * klass) {
	downloader_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (DownloaderPrivate));
	G_OBJECT_CLASS (klass)->finalize = downloader_finalize;
	g_signal_new ("finished", TYPE_DOWNLOADER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void downloader_instance_init (Downloader * self) {
	self->priv = DOWNLOADER_GET_PRIVATE (self);
}


static void downloader_finalize (GObject* obj) {
	Downloader * self;
	self = DOWNLOADER (obj);
	downloader_info_destroy (&self->priv->dli);
	_g_free0 (self->title);
	_g_free0 (self->priv->url);
	_g_free0 (self->local_file_path);
	G_OBJECT_CLASS (downloader_parent_class)->finalize (obj);
}


GType downloader_get_type (void) {
	static volatile gsize downloader_type_id__volatile = 0;
	if (g_once_init_enter (&downloader_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DownloaderClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) downloader_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Downloader), 0, (GInstanceInitFunc) downloader_instance_init, NULL };
		GType downloader_type_id;
		downloader_type_id = g_type_register_static (G_TYPE_OBJECT, "Downloader", &g_define_type_info, 0);
		g_once_init_leave (&downloader_type_id__volatile, downloader_type_id);
	}
	return downloader_type_id__volatile;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



