/* RSSXMLParser.c generated by valac 0.16.0, the Vala compiler
 * generated from RSSXMLParser.vala, do not modify */

/* Part of MuttonChop
 * copyright 2012 Jezra Lickter
 * Licensed GPLv3
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <libxml/tree.h>
#include <glib/gstdio.h>
#include <libxml/parser.h>


#define TYPE_RSSXML_PARSER (rssxml_parser_get_type ())
#define RSSXML_PARSER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_RSSXML_PARSER, RSSXMLParser))
#define RSSXML_PARSER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_RSSXML_PARSER, RSSXMLParserClass))
#define IS_RSSXML_PARSER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_RSSXML_PARSER))
#define IS_RSSXML_PARSER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_RSSXML_PARSER))
#define RSSXML_PARSER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_RSSXML_PARSER, RSSXMLParserClass))

typedef struct _RSSXMLParser RSSXMLParser;
typedef struct _RSSXMLParserClass RSSXMLParserClass;
typedef struct _RSSXMLParserPrivate RSSXMLParserPrivate;

#define TYPE_EPISODE (episode_get_type ())
typedef struct _Episode Episode;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))

typedef enum  {
	XML_ERROR_FILE_NOT_FOUND,
	XML_ERROR_XML_DOCUMENT_EMPTY
} XmlError;
#define XML_ERROR xml_error_quark ()
typedef enum  {
	FEED_ERROR_MISSING_CHANNEL
} FeedError;
#define FEED_ERROR feed_error_quark ()
struct _RSSXMLParser {
	GObject parent_instance;
	RSSXMLParserPrivate * priv;
};

struct _RSSXMLParserClass {
	GObjectClass parent_class;
};

struct _Episode {
	gchar* id;
	gchar* title;
	gchar* link;
	gchar* description;
	gchar* url;
	gchar* local_path;
	gchar* length;
	gchar* dl_length;
	gint64 local_file_size;
	gchar* server_length;
	gchar* pubdate;
	gboolean played;
	gboolean downloaded;
	gchar* feed_id;
	gchar* feed_title;
};

struct _RSSXMLParserPrivate {
	gchar* _feed_title;
	gchar* _feed_description;
	gchar* _feed_link;
	gboolean debug;
	Episode* feed_episodes;
	gint feed_episodes_length1;
	gint _feed_episodes_size_;
};


static gpointer rssxml_parser_parent_class = NULL;

GQuark xml_error_quark (void);
GQuark feed_error_quark (void);
GType rssxml_parser_get_type (void) G_GNUC_CONST;
GType episode_get_type (void) G_GNUC_CONST;
Episode* episode_dup (const Episode* self);
void episode_free (Episode* self);
void episode_copy (const Episode* self, Episode* dest);
void episode_destroy (Episode* self);
#define RSSXML_PARSER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_RSSXML_PARSER, RSSXMLParserPrivate))
enum  {
	RSSXML_PARSER_DUMMY_PROPERTY,
	RSSXML_PARSER_FEED_TITLE,
	RSSXML_PARSER_FEED_DESCRIPTION,
	RSSXML_PARSER_FEED_LINK
};
static void _vala_Episode_array_free (Episode* array, gint array_length);
void rssxml_parser_clear (RSSXMLParser* self);
void rssxml_parser_set_feed_title (RSSXMLParser* self, const gchar* value);
void rssxml_parser_set_feed_description (RSSXMLParser* self, const gchar* value);
void rssxml_parser_set_feed_link (RSSXMLParser* self, const gchar* value);
void rssxml_parser_set_debug (RSSXMLParser* self, gboolean val);
static void rssxml_parser_p_debug (RSSXMLParser* self, const gchar* s);
static void rssxml_parser_parse_item_node (RSSXMLParser* self, xmlNode* the_node);
static void _vala_array_add14 (Episode** array, int* length, int* size, const Episode* value);
void rssxml_parser_parse_file (RSSXMLParser* self, const gchar* file, GError** error);
const gchar* rssxml_parser_get_feed_link (RSSXMLParser* self);
void rssxml_parser_clean_up (RSSXMLParser* self);
Episode* rssxml_parser_get_feed_episodes (RSSXMLParser* self, int* result_length1);
static Episode* _vala_array_dup8 (Episode* self, int length);
RSSXMLParser* rssxml_parser_new (void);
RSSXMLParser* rssxml_parser_construct (GType object_type);
const gchar* rssxml_parser_get_feed_title (RSSXMLParser* self);
const gchar* rssxml_parser_get_feed_description (RSSXMLParser* self);
static GObject * rssxml_parser_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void rssxml_parser_finalize (GObject* obj);
static void _vala_rssxml_parser_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_rssxml_parser_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


GQuark xml_error_quark (void) {
	return g_quark_from_static_string ("xml_error-quark");
}


GQuark feed_error_quark (void) {
	return g_quark_from_static_string ("feed_error-quark");
}


static void _vala_Episode_array_free (Episode* array, gint array_length) {
	if (array != NULL) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			episode_destroy (&array[i]);
		}
	}
	g_free (array);
}


void rssxml_parser_clear (RSSXMLParser* self) {
	Episode* _tmp0_ = NULL;
	g_return_if_fail (self != NULL);
	rssxml_parser_set_feed_title (self, "");
	rssxml_parser_set_feed_description (self, "");
	rssxml_parser_set_feed_link (self, "");
	_tmp0_ = g_new0 (Episode, 0);
	self->priv->feed_episodes = (_vala_Episode_array_free (self->priv->feed_episodes, self->priv->feed_episodes_length1), NULL);
	self->priv->feed_episodes = _tmp0_;
	self->priv->feed_episodes_length1 = 0;
	self->priv->_feed_episodes_size_ = self->priv->feed_episodes_length1;
}


void rssxml_parser_set_debug (RSSXMLParser* self, gboolean val) {
	gboolean _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = val;
	self->priv->debug = _tmp0_;
}


static const gchar* string_to_string (const gchar* self) {
	const gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	result = self;
	return result;
}


static void rssxml_parser_p_debug (RSSXMLParser* self, const gchar* s) {
	gboolean _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (s != NULL);
	_tmp0_ = self->priv->debug;
	if (_tmp0_) {
		FILE* _tmp1_;
		const gchar* _tmp2_;
		const gchar* _tmp3_ = NULL;
		gchar* _tmp4_ = NULL;
		gchar* _tmp5_;
		_tmp1_ = stdout;
		_tmp2_ = s;
		_tmp3_ = string_to_string (_tmp2_);
		_tmp4_ = g_strconcat (_tmp3_, "\n", NULL);
		_tmp5_ = _tmp4_;
		fprintf (_tmp1_, "%s", _tmp5_);
		_g_free0 (_tmp5_);
	}
}


static void _vala_array_add14 (Episode** array, int* length, int* size, const Episode* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (Episode, *array, *size);
	}
	(*array)[(*length)++] = *value;
}


static void rssxml_parser_parse_item_node (RSSXMLParser* self, xmlNode* the_node) {
	xmlNode* _tmp0_;
	xmlNode* _tmp1_;
	xmlNode* node_children;
	xmlNode* _tmp2_;
	xmlNode* _tmp3_;
	xmlNode* iter;
	Episode fe = {0};
	gchar* iter_node_name = NULL;
	Episode* _tmp26_;
	gint _tmp26__length1;
	Episode _tmp27_;
	Episode _tmp28_ = {0};
	g_return_if_fail (self != NULL);
	_tmp0_ = the_node;
	_tmp1_ = _tmp0_->children;
	node_children = _tmp1_;
	_tmp2_ = node_children;
	_tmp3_ = _tmp2_->next;
	iter = _tmp3_;
	memset (&fe, 0, sizeof (Episode));
	while (TRUE) {
		xmlNode* _tmp4_;
		xmlNode* _tmp5_;
		xmlElementType _tmp6_;
		xmlNode* _tmp24_;
		xmlNode* _tmp25_;
		_tmp4_ = iter;
		if (!(_tmp4_ != NULL)) {
			break;
		}
		_tmp5_ = iter;
		_tmp6_ = _tmp5_->type;
		if (_tmp6_ != XML_ELEMENT_NODE) {
		} else {
			xmlNode* _tmp7_;
			const gchar* _tmp8_;
			gchar* _tmp9_;
			const gchar* _tmp10_;
			const gchar* _tmp11_;
			GQuark _tmp13_ = 0U;
			static GQuark _tmp12_label0 = 0;
			static GQuark _tmp12_label1 = 0;
			static GQuark _tmp12_label2 = 0;
			static GQuark _tmp12_label3 = 0;
			_tmp7_ = iter;
			_tmp8_ = _tmp7_->name;
			_tmp9_ = g_strdup (_tmp8_);
			_g_free0 (iter_node_name);
			iter_node_name = _tmp9_;
			_tmp10_ = iter_node_name;
			_tmp11_ = _tmp10_;
			_tmp13_ = (NULL == _tmp11_) ? 0 : g_quark_from_string (_tmp11_);
			if (_tmp13_ == ((0 != _tmp12_label0) ? _tmp12_label0 : (_tmp12_label0 = g_quark_from_static_string ("title")))) {
				switch (0) {
					default:
					{
						xmlNode* _tmp14_;
						gchar* _tmp15_ = NULL;
						_tmp14_ = iter;
						_tmp15_ = xmlNodeGetContent (_tmp14_);
						_g_free0 (fe.title);
						fe.title = _tmp15_;
						break;
					}
				}
			} else if (_tmp13_ == ((0 != _tmp12_label1) ? _tmp12_label1 : (_tmp12_label1 = g_quark_from_static_string ("description")))) {
				switch (0) {
					default:
					{
						xmlNode* _tmp16_;
						gchar* _tmp17_ = NULL;
						_tmp16_ = iter;
						_tmp17_ = xmlNodeGetContent (_tmp16_);
						_g_free0 (fe.description);
						fe.description = _tmp17_;
						break;
					}
				}
			} else if (_tmp13_ == ((0 != _tmp12_label2) ? _tmp12_label2 : (_tmp12_label2 = g_quark_from_static_string ("enclosure")))) {
				switch (0) {
					default:
					{
						xmlNode* _tmp18_;
						gchar* _tmp19_ = NULL;
						xmlNode* _tmp20_;
						gchar* _tmp21_ = NULL;
						_tmp18_ = iter;
						_tmp19_ = xmlGetProp (_tmp18_, "url");
						_g_free0 (fe.url);
						fe.url = _tmp19_;
						_tmp20_ = iter;
						_tmp21_ = xmlGetProp (_tmp20_, "length");
						_g_free0 (fe.length);
						fe.length = _tmp21_;
						break;
					}
				}
			} else if (_tmp13_ == ((0 != _tmp12_label3) ? _tmp12_label3 : (_tmp12_label3 = g_quark_from_static_string ("pubDate")))) {
				switch (0) {
					default:
					{
						xmlNode* _tmp22_;
						gchar* _tmp23_ = NULL;
						_tmp22_ = iter;
						_tmp23_ = xmlNodeGetContent (_tmp22_);
						_g_free0 (fe.pubdate);
						fe.pubdate = _tmp23_;
						break;
					}
				}
			}
		}
		_tmp24_ = iter;
		_tmp25_ = _tmp24_->next;
		iter = _tmp25_;
	}
	_tmp26_ = self->priv->feed_episodes;
	_tmp26__length1 = self->priv->feed_episodes_length1;
	_tmp27_ = fe;
	episode_copy (&_tmp27_, &_tmp28_);
	_vala_array_add14 (&self->priv->feed_episodes, &self->priv->feed_episodes_length1, &self->priv->_feed_episodes_size_, &_tmp28_);
	_g_free0 (iter_node_name);
	episode_destroy (&fe);
}


static gchar* string_replace (const gchar* self, const gchar* old, const gchar* replacement) {
	gchar* result = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	{
		const gchar* _tmp0_;
		gchar* _tmp1_ = NULL;
		gchar* _tmp2_;
		GRegex* _tmp3_;
		GRegex* _tmp4_;
		GRegex* regex;
		GRegex* _tmp5_;
		const gchar* _tmp6_;
		gchar* _tmp7_ = NULL;
		gchar* _tmp8_;
		_tmp0_ = old;
		_tmp1_ = g_regex_escape_string (_tmp0_, -1);
		_tmp2_ = _tmp1_;
		_tmp3_ = g_regex_new (_tmp2_, 0, 0, &_inner_error_);
		_tmp4_ = _tmp3_;
		_g_free0 (_tmp2_);
		regex = _tmp4_;
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch17_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp5_ = regex;
		_tmp6_ = replacement;
		_tmp7_ = g_regex_replace_literal (_tmp5_, self, (gssize) (-1), 0, _tmp6_, 0, &_inner_error_);
		_tmp8_ = _tmp7_;
		if (_inner_error_ != NULL) {
			_g_regex_unref0 (regex);
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch17_g_regex_error;
			}
			_g_regex_unref0 (regex);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		result = _tmp8_;
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally17;
	__catch17_g_regex_error:
	{
		GError* e = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		g_assert_not_reached ();
		_g_error_free0 (e);
	}
	__finally17:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
}


void rssxml_parser_parse_file (RSSXMLParser* self, const gchar* file, GError** error) {
	FILE* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* file_text;
	gsize length;
	const gchar* _tmp29_;
	gchar* _tmp30_ = NULL;
	const gchar* _tmp31_;
	const gchar* _tmp32_;
	gint _tmp33_;
	gint _tmp34_;
	xmlDoc* _tmp35_ = NULL;
	xmlDoc* xml_doc;
	xmlDoc* _tmp36_;
	xmlDoc* _tmp46_;
	xmlNode* _tmp47_ = NULL;
	xmlNode* root_node;
	xmlNode* _tmp48_;
	xmlNode* _tmp59_;
	xmlNode* _tmp60_;
	xmlNode* root_children;
	xmlNode* _tmp61_;
	xmlNode* _tmp62_;
	xmlNode* root_iter;
	xmlNode* _tmp63_;
	const gchar* _tmp64_;
	gchar* _tmp65_;
	gchar* _tmp66_;
	xmlNode* _tmp67_;
	gulong _tmp68_ = 0UL;
	gulong child_count;
	gulong iter_count;
	gchar* iter_node_name = NULL;
	xmlNode* _tmp78_;
	const gchar* _tmp79_;
	xmlDoc* _tmp114_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (file != NULL);
	_tmp0_ = stdout;
	_tmp1_ = file;
	_tmp2_ = string_to_string (_tmp1_);
	_tmp3_ = g_strconcat ("parsing: ", _tmp2_, "\n", NULL);
	_tmp4_ = _tmp3_;
	fprintf (_tmp0_, "%s", _tmp4_);
	_g_free0 (_tmp4_);
	rssxml_parser_clear (self);
	_tmp5_ = g_strdup ("");
	file_text = _tmp5_;
	length = (gsize) 0;
	{
		const gchar* _tmp6_;
		gchar* _tmp7_ = NULL;
		gsize _tmp8_ = 0UL;
		gboolean _tmp9_ = FALSE;
		gboolean _tmp10_;
		_tmp6_ = file;
		_tmp9_ = g_file_get_contents (_tmp6_, &_tmp7_, &_tmp8_, &_inner_error_);
		_g_free0 (file_text);
		file_text = _tmp7_;
		length = _tmp8_;
		_tmp10_ = _tmp9_;
		if (_inner_error_ != NULL) {
			goto __catch16_g_error;
		}
		if (!_tmp10_) {
			FILE* _tmp11_;
			const gchar* _tmp12_;
			gchar* _tmp13_;
			gchar* _tmp14_;
			const gchar* _tmp15_;
			gchar* _tmp16_;
			gchar* _tmp17_;
			GError* _tmp18_;
			GError* _tmp19_;
			_tmp11_ = stderr;
			_tmp12_ = file;
			_tmp13_ = g_strconcat (_tmp12_, " is not readable", NULL);
			_tmp14_ = _tmp13_;
			fprintf (_tmp11_, "%s", _tmp14_);
			_g_free0 (_tmp14_);
			_tmp15_ = file;
			_tmp16_ = g_strconcat (_tmp15_, " is not readable", NULL);
			_tmp17_ = _tmp16_;
			_tmp18_ = g_error_new_literal (XML_ERROR, XML_ERROR_FILE_NOT_FOUND, _tmp17_);
			_tmp19_ = _tmp18_;
			_g_free0 (_tmp17_);
			_inner_error_ = _tmp19_;
			goto __catch16_g_error;
		}
	}
	goto __finally16;
	__catch16_g_error:
	{
		GError* e = NULL;
		FILE* _tmp20_;
		const gchar* _tmp21_;
		GError* _tmp22_;
		const gchar* _tmp23_;
		const gchar* _tmp24_;
		gchar* _tmp25_;
		gchar* _tmp26_;
		GError* _tmp27_;
		GError* _tmp28_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp20_ = stderr;
		_tmp21_ = file;
		_tmp22_ = e;
		_tmp23_ = _tmp22_->message;
		fprintf (_tmp20_, "%s: %s\n", _tmp21_, _tmp23_);
		_tmp24_ = file;
		_tmp25_ = g_strconcat (_tmp24_, " is not readable", NULL);
		_tmp26_ = _tmp25_;
		_tmp27_ = g_error_new_literal (XML_ERROR, XML_ERROR_FILE_NOT_FOUND, _tmp26_);
		_tmp28_ = _tmp27_;
		_g_free0 (_tmp26_);
		_inner_error_ = _tmp28_;
		_g_error_free0 (e);
		goto __finally16;
	}
	__finally16:
	if (_inner_error_ != NULL) {
		if ((_inner_error_->domain == XML_ERROR) || (_inner_error_->domain == FEED_ERROR)) {
			g_propagate_error (error, _inner_error_);
			_g_free0 (file_text);
			return;
		} else {
			_g_free0 (file_text);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	_tmp29_ = file_text;
	_tmp30_ = string_replace (_tmp29_, "><", ">\n<");
	_g_free0 (file_text);
	file_text = _tmp30_;
	_tmp31_ = file_text;
	_tmp32_ = file_text;
	_tmp33_ = strlen (_tmp32_);
	_tmp34_ = _tmp33_;
	_tmp35_ = xmlReadMemory (_tmp31_, _tmp34_, NULL, NULL, 0);
	xml_doc = _tmp35_;
	_tmp36_ = xml_doc;
	if (_tmp36_ == NULL) {
		FILE* _tmp37_;
		const gchar* _tmp38_;
		gchar* _tmp39_;
		gchar* _tmp40_;
		const gchar* _tmp41_;
		gchar* _tmp42_;
		gchar* _tmp43_;
		GError* _tmp44_;
		GError* _tmp45_;
		_tmp37_ = stderr;
		_tmp38_ = file;
		_tmp39_ = g_strconcat (_tmp38_, " is not readable", NULL);
		_tmp40_ = _tmp39_;
		fprintf (_tmp37_, "%s", _tmp40_);
		_g_free0 (_tmp40_);
		_tmp41_ = file;
		_tmp42_ = g_strconcat (_tmp41_, " is not readable", NULL);
		_tmp43_ = _tmp42_;
		_tmp44_ = g_error_new_literal (XML_ERROR, XML_ERROR_FILE_NOT_FOUND, _tmp43_);
		_tmp45_ = _tmp44_;
		_g_free0 (_tmp43_);
		_inner_error_ = _tmp45_;
		if ((_inner_error_->domain == XML_ERROR) || (_inner_error_->domain == FEED_ERROR)) {
			g_propagate_error (error, _inner_error_);
			_g_free0 (file_text);
			return;
		} else {
			_g_free0 (file_text);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	_tmp46_ = xml_doc;
	_tmp47_ = xmlDocGetRootElement (_tmp46_);
	root_node = _tmp47_;
	_tmp48_ = root_node;
	if (_tmp48_ == NULL) {
		xmlDoc* _tmp49_;
		FILE* _tmp50_;
		const gchar* _tmp51_;
		gchar* _tmp52_;
		gchar* _tmp53_;
		const gchar* _tmp54_;
		gchar* _tmp55_;
		gchar* _tmp56_;
		GError* _tmp57_;
		GError* _tmp58_;
		_tmp49_ = xml_doc;
		xmlFreeDoc (_tmp49_);
		_tmp50_ = stderr;
		_tmp51_ = file;
		_tmp52_ = g_strconcat (_tmp51_, " is empty", NULL);
		_tmp53_ = _tmp52_;
		fprintf (_tmp50_, "%s", _tmp53_);
		_g_free0 (_tmp53_);
		_tmp54_ = file;
		_tmp55_ = g_strconcat (_tmp54_, " is empty", NULL);
		_tmp56_ = _tmp55_;
		_tmp57_ = g_error_new_literal (XML_ERROR, XML_ERROR_XML_DOCUMENT_EMPTY, _tmp56_);
		_tmp58_ = _tmp57_;
		_g_free0 (_tmp56_);
		_inner_error_ = _tmp58_;
		if ((_inner_error_->domain == XML_ERROR) || (_inner_error_->domain == FEED_ERROR)) {
			g_propagate_error (error, _inner_error_);
			_g_free0 (file_text);
			return;
		} else {
			_g_free0 (file_text);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	_tmp59_ = root_node;
	_tmp60_ = _tmp59_->children;
	root_children = _tmp60_;
	_tmp61_ = root_children;
	_tmp62_ = _tmp61_->next;
	root_iter = _tmp62_;
	_tmp63_ = root_iter;
	_tmp64_ = _tmp63_->name;
	_tmp65_ = g_strconcat ("root_iter name: ", _tmp64_, NULL);
	_tmp66_ = _tmp65_;
	rssxml_parser_p_debug (self, _tmp66_);
	_g_free0 (_tmp66_);
	_tmp67_ = root_node;
	_tmp68_ = xmlChildElementCount (_tmp67_);
	child_count = _tmp68_;
	iter_count = (gulong) 1;
	while (TRUE) {
		gboolean _tmp69_ = FALSE;
		xmlNode* _tmp70_;
		const gchar* _tmp71_;
		gboolean _tmp74_;
		xmlNode* _tmp75_;
		xmlNode* _tmp76_;
		gulong _tmp77_;
		_tmp70_ = root_iter;
		_tmp71_ = _tmp70_->name;
		if (g_strcmp0 (_tmp71_, "channel") != 0) {
			gulong _tmp72_;
			gulong _tmp73_;
			_tmp72_ = iter_count;
			_tmp73_ = child_count;
			_tmp69_ = _tmp72_ < _tmp73_;
		} else {
			_tmp69_ = FALSE;
		}
		_tmp74_ = _tmp69_;
		if (!_tmp74_) {
			break;
		}
		_tmp75_ = root_iter;
		_tmp76_ = _tmp75_->next;
		root_iter = _tmp76_;
		_tmp77_ = iter_count;
		iter_count = _tmp77_ + 1;
	}
	_tmp78_ = root_iter;
	_tmp79_ = _tmp78_->name;
	if (g_strcmp0 (_tmp79_, "channel") == 0) {
		xmlNode* _tmp80_;
		xmlNode* _tmp81_;
		xmlNode* iter;
		xmlNode* _tmp82_;
		xmlNode* _tmp83_;
		_tmp80_ = root_iter;
		_tmp81_ = _tmp80_->children;
		iter = _tmp81_;
		_tmp82_ = iter;
		_tmp83_ = _tmp82_->next;
		iter = _tmp83_;
		while (TRUE) {
			xmlNode* _tmp84_;
			xmlNode* _tmp85_;
			xmlElementType _tmp86_;
			xmlNode* _tmp107_;
			xmlNode* _tmp108_;
			_tmp84_ = iter;
			if (!(_tmp84_ != NULL)) {
				break;
			}
			_tmp85_ = iter;
			_tmp86_ = _tmp85_->type;
			if (_tmp86_ == XML_ELEMENT_NODE) {
				xmlNode* _tmp87_;
				const gchar* _tmp88_;
				gchar* _tmp89_;
				const gchar* _tmp90_;
				const gchar* _tmp91_;
				GQuark _tmp93_ = 0U;
				static GQuark _tmp92_label0 = 0;
				static GQuark _tmp92_label1 = 0;
				static GQuark _tmp92_label2 = 0;
				static GQuark _tmp92_label3 = 0;
				_tmp87_ = iter;
				_tmp88_ = _tmp87_->name;
				_tmp89_ = g_strdup (_tmp88_);
				_g_free0 (iter_node_name);
				iter_node_name = _tmp89_;
				_tmp90_ = iter_node_name;
				_tmp91_ = _tmp90_;
				_tmp93_ = (NULL == _tmp91_) ? 0 : g_quark_from_string (_tmp91_);
				if (_tmp93_ == ((0 != _tmp92_label0) ? _tmp92_label0 : (_tmp92_label0 = g_quark_from_static_string ("title")))) {
					switch (0) {
						default:
						{
							xmlNode* _tmp94_;
							gchar* _tmp95_ = NULL;
							gchar* _tmp96_;
							_tmp94_ = iter;
							_tmp95_ = xmlNodeGetContent (_tmp94_);
							_tmp96_ = _tmp95_;
							rssxml_parser_set_feed_title (self, _tmp96_);
							_g_free0 (_tmp96_);
							break;
						}
					}
				} else if (_tmp93_ == ((0 != _tmp92_label1) ? _tmp92_label1 : (_tmp92_label1 = g_quark_from_static_string ("description")))) {
					switch (0) {
						default:
						{
							xmlNode* _tmp97_;
							gchar* _tmp98_ = NULL;
							gchar* _tmp99_;
							_tmp97_ = iter;
							_tmp98_ = xmlNodeGetContent (_tmp97_);
							_tmp99_ = _tmp98_;
							rssxml_parser_set_feed_description (self, _tmp99_);
							_g_free0 (_tmp99_);
							break;
						}
					}
				} else if (_tmp93_ == ((0 != _tmp92_label2) ? _tmp92_label2 : (_tmp92_label2 = g_quark_from_static_string ("link")))) {
					switch (0) {
						default:
						{
							const gchar* _tmp100_;
							gint _tmp101_;
							gint _tmp102_;
							_tmp100_ = self->priv->_feed_link;
							_tmp101_ = strlen (_tmp100_);
							_tmp102_ = _tmp101_;
							if (_tmp102_ == 0) {
								xmlNode* _tmp103_;
								gchar* _tmp104_ = NULL;
								gchar* _tmp105_;
								_tmp103_ = iter;
								_tmp104_ = xmlNodeGetContent (_tmp103_);
								_tmp105_ = _tmp104_;
								rssxml_parser_set_feed_link (self, _tmp105_);
								_g_free0 (_tmp105_);
							}
							break;
						}
					}
				} else if (_tmp93_ == ((0 != _tmp92_label3) ? _tmp92_label3 : (_tmp92_label3 = g_quark_from_static_string ("item")))) {
					switch (0) {
						default:
						{
							xmlNode* _tmp106_;
							_tmp106_ = iter;
							rssxml_parser_parse_item_node (self, _tmp106_);
							break;
						}
					}
				} else {
					switch (0) {
						default:
						{
							break;
						}
					}
				}
			}
			_tmp107_ = iter;
			_tmp108_ = _tmp107_->next;
			iter = _tmp108_;
		}
	} else {
		const gchar* _tmp109_;
		gchar* _tmp110_;
		gchar* _tmp111_;
		GError* _tmp112_;
		GError* _tmp113_;
		_tmp109_ = file;
		_tmp110_ = g_strconcat (_tmp109_, " is missing the 'channel' element", NULL);
		_tmp111_ = _tmp110_;
		_tmp112_ = g_error_new_literal (FEED_ERROR, FEED_ERROR_MISSING_CHANNEL, _tmp111_);
		_tmp113_ = _tmp112_;
		_g_free0 (_tmp111_);
		_inner_error_ = _tmp113_;
		if ((_inner_error_->domain == XML_ERROR) || (_inner_error_->domain == FEED_ERROR)) {
			g_propagate_error (error, _inner_error_);
			_g_free0 (iter_node_name);
			_g_free0 (file_text);
			return;
		} else {
			_g_free0 (iter_node_name);
			_g_free0 (file_text);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	_tmp114_ = xml_doc;
	xmlFreeDoc (_tmp114_);
	_g_free0 (iter_node_name);
	_g_free0 (file_text);
}


void rssxml_parser_clean_up (RSSXMLParser* self) {
	g_return_if_fail (self != NULL);
	xmlCleanupParser ();
}


static Episode* _vala_array_dup8 (Episode* self, int length) {
	Episode* result;
	int i;
	result = g_new0 (Episode, length);
	for (i = 0; i < length; i++) {
		Episode _tmp0_ = {0};
		episode_copy (&self[i], &_tmp0_);
		result[i] = _tmp0_;
	}
	return result;
}


Episode* rssxml_parser_get_feed_episodes (RSSXMLParser* self, int* result_length1) {
	Episode* result = NULL;
	Episode* _tmp0_;
	gint _tmp0__length1;
	Episode* _tmp1_;
	gint _tmp1__length1;
	Episode* _tmp2_;
	gint _tmp2__length1;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->feed_episodes;
	_tmp0__length1 = self->priv->feed_episodes_length1;
	_tmp1_ = (_tmp0_ != NULL) ? _vala_array_dup8 (_tmp0_, _tmp0__length1) : ((gpointer) _tmp0_);
	_tmp1__length1 = _tmp0__length1;
	_tmp2_ = _tmp1_;
	_tmp2__length1 = _tmp1__length1;
	if (result_length1) {
		*result_length1 = _tmp2__length1;
	}
	result = _tmp2_;
	return result;
}


RSSXMLParser* rssxml_parser_construct (GType object_type) {
	RSSXMLParser * self = NULL;
	self = (RSSXMLParser*) g_object_new (object_type, NULL);
	return self;
}


RSSXMLParser* rssxml_parser_new (void) {
	return rssxml_parser_construct (TYPE_RSSXML_PARSER);
}


const gchar* rssxml_parser_get_feed_title (RSSXMLParser* self) {
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_feed_title;
	result = _tmp0_;
	return result;
}


void rssxml_parser_set_feed_title (RSSXMLParser* self, const gchar* value) {
	const gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_feed_title);
	self->priv->_feed_title = _tmp1_;
	g_object_notify ((GObject *) self, "feed-title");
}


const gchar* rssxml_parser_get_feed_description (RSSXMLParser* self) {
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_feed_description;
	result = _tmp0_;
	return result;
}


void rssxml_parser_set_feed_description (RSSXMLParser* self, const gchar* value) {
	const gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_feed_description);
	self->priv->_feed_description = _tmp1_;
	g_object_notify ((GObject *) self, "feed-description");
}


const gchar* rssxml_parser_get_feed_link (RSSXMLParser* self) {
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_feed_link;
	result = _tmp0_;
	return result;
}


void rssxml_parser_set_feed_link (RSSXMLParser* self, const gchar* value) {
	const gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_feed_link);
	self->priv->_feed_link = _tmp1_;
	g_object_notify ((GObject *) self, "feed-link");
}


static GObject * rssxml_parser_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	RSSXMLParser * self;
	parent_class = G_OBJECT_CLASS (rssxml_parser_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = RSSXML_PARSER (obj);
	xmlInitParser ();
	return obj;
}


static void rssxml_parser_class_init (RSSXMLParserClass * klass) {
	rssxml_parser_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (RSSXMLParserPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_rssxml_parser_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_rssxml_parser_set_property;
	G_OBJECT_CLASS (klass)->constructor = rssxml_parser_constructor;
	G_OBJECT_CLASS (klass)->finalize = rssxml_parser_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), RSSXML_PARSER_FEED_TITLE, g_param_spec_string ("feed-title", "feed-title", "feed-title", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), RSSXML_PARSER_FEED_DESCRIPTION, g_param_spec_string ("feed-description", "feed-description", "feed-description", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), RSSXML_PARSER_FEED_LINK, g_param_spec_string ("feed-link", "feed-link", "feed-link", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
}


static void rssxml_parser_instance_init (RSSXMLParser * self) {
	self->priv = RSSXML_PARSER_GET_PRIVATE (self);
}


static void rssxml_parser_finalize (GObject* obj) {
	RSSXMLParser * self;
	self = RSSXML_PARSER (obj);
	_g_free0 (self->priv->_feed_title);
	_g_free0 (self->priv->_feed_description);
	_g_free0 (self->priv->_feed_link);
	self->priv->feed_episodes = (_vala_Episode_array_free (self->priv->feed_episodes, self->priv->feed_episodes_length1), NULL);
	G_OBJECT_CLASS (rssxml_parser_parent_class)->finalize (obj);
}


GType rssxml_parser_get_type (void) {
	static volatile gsize rssxml_parser_type_id__volatile = 0;
	if (g_once_init_enter (&rssxml_parser_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (RSSXMLParserClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) rssxml_parser_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (RSSXMLParser), 0, (GInstanceInitFunc) rssxml_parser_instance_init, NULL };
		GType rssxml_parser_type_id;
		rssxml_parser_type_id = g_type_register_static (G_TYPE_OBJECT, "RSSXMLParser", &g_define_type_info, 0);
		g_once_init_leave (&rssxml_parser_type_id__volatile, rssxml_parser_type_id);
	}
	return rssxml_parser_type_id__volatile;
}


static void _vala_rssxml_parser_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	RSSXMLParser * self;
	self = RSSXML_PARSER (object);
	switch (property_id) {
		case RSSXML_PARSER_FEED_TITLE:
		g_value_set_string (value, rssxml_parser_get_feed_title (self));
		break;
		case RSSXML_PARSER_FEED_DESCRIPTION:
		g_value_set_string (value, rssxml_parser_get_feed_description (self));
		break;
		case RSSXML_PARSER_FEED_LINK:
		g_value_set_string (value, rssxml_parser_get_feed_link (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_rssxml_parser_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	RSSXMLParser * self;
	self = RSSXML_PARSER (object);
	switch (property_id) {
		case RSSXML_PARSER_FEED_TITLE:
		rssxml_parser_set_feed_title (self, g_value_get_string (value));
		break;
		case RSSXML_PARSER_FEED_DESCRIPTION:
		rssxml_parser_set_feed_description (self, g_value_get_string (value));
		break;
		case RSSXML_PARSER_FEED_LINK:
		rssxml_parser_set_feed_link (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



